#ifndef	_file_data_H_
#define	_file_data_H_


typedef	enum	{
	DATA_NOT_STARTED,		/*ɤƤʤǥեȾ	*/
	DATA_NOT_RUNNING,		/*WGET¹ԤƤʤ	*/
	DATA_NOT_CONNECTED,		/*WGETͥ	*/
	DATA_CONNECTED,			/*⡼ȥۥȤ³줿	*/
	DATA_RETRIEVING,		/*	*/
	DATA_COMPLETED,			/*λ	*/
	DATA_STOP					/*	*/
}DataState;


typedef	struct{
	
	pid_t	wget_pid;		/*wget¹Ԥҥץpid	*/
	gint	log_fd;			/*wgetΥ	*/
	gint log_tag; 			/*gtk_timeout_addμ̻*/

	gchar 	*url;			/*ɤեURL	*/
	gchar 	*directry;		/*ɤǥ쥯ȥ	*/
	gchar	*filename;		/*ե̾	*/

	gchar	*local_filename;/*ʬΥԥ塼˥ɤ̾	*/
	gboolean use_proxy;	/*ץλѥե饰	*/
	gboolean use_auto_dl;	/*ưɤλѥե饰	*/

	gchar	*line;			/*wgetν	*/
	gint	  line_pos;		/*wgetν	*/

	guint32	total_size;		/*ȡ륵(Хñ)	*/
	guint	total_time;		/*ȡ()	*/

	time_t	session_start_time;	/*	Ȼλ	*/
	guint32	session_start_size;	/*	ȻΥե륵	*/
	guint32	session_elapsed;
	guint32	cur_size;
	
	time_t	diff_time;
	guint32 diff_size;
	
	gint	percent;		/*	ߤΡ	*/

	DataState	state;
	
	GtkWidget *Clist;
	guint	id;				/*FileData̤ID	*/
}FileData;

FileData *data_create(gchar *url, gchar *dir, gboolean	proxy,gboolean	auto_dl);
void	file_data_start_download(FileData	*file_data);
void	file_data_stop_download(FileData	*file_data);
void	file_data_restart_download(FileData	*file_data);
void	file_data_set_state (FileData *file_data, DataState state, gboolean sync);
void	file_data_set_total_size (FileData *file_data, guint32 total_size,gboolean sync);
void	file_data_update(FileData *file_data, gboolean sync);
void	file_data_set_use_proxy(FileData *file_data ,gboolean use_proxy);
void	file_data_set_url(FileData *file_data ,gint row ,gchar *url);
void	file_data_set_directry(FileData *file_data ,gchar *directry);
void	file_data_free(FileData *file_data);
#endif  

