/* ǭ
 *  Copyright (C) 2000,2001 gchar
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include<gnome.h>
#include<libgnomeui/gnome-window-icon.h>
#include<libgnomeui/gnome-appbar.h>
#include<signal.h>
#include"giko_download.h"
#include"file_clist.h"
#include"file_data.h"
#include"log.h"
#include"appbar.h"


GtkWidget *main_window;
GtkWidget *scroll_window;
extern FileClist *file_clist;
gint	appbar_timeout;

gint	giko_download_flag = 0;	/*	Υץ򳫤Τ1ĤΤ	*/

/*ΥեǡȤ˻ȤID*/
gint	next_file_id = 0;

/*	ȥ꡼¸ʤɤ⤷ʤ	*/
/*
void save_applet_geometry()
{
	
    gchar *geometry;

    
    gnome_config_push_prefix ("/giko_download/Display/");
    geometry = gnome_geometry_string (main_window->window);
    gnome_config_set_string ("geometry", geometry);
    g_free (geometry);
    gnome_config_pop_prefix ();
    gnome_config_sync ();
}
*/

void dialog_clicked_cb(GnomeDialog * dialog, gint button_number, gpointer widget)
{
	FileData *file_data;
	gint i;
	gint rows;
	
	switch(button_number){
		case 0:{	/*button_ok*/

			
			/*	ȥ꡼¸	(礭)*/
			/*save_applet_geometry();*/

			giko_download_flag = 0;
			gtk_timeout_remove(appbar_timeout);
			
			/*ƥߤƤ齪λ*/
			rows = GTK_CLIST(file_clist->clist)->rows;
			if(rows != 0){
				for(i = 0; i <  rows ;i++){
					file_data = file_data = (FileData *)gtk_clist_get_row_data(GTK_CLIST(file_clist->clist),i);
					g_print("file = %s\n",file_data->filename);
					file_data_stop_download(file_data);
				}
			}
			/*եǡΥγ*/
			gtk_clist_freeze(GTK_CLIST(file_clist->clist));
			gtk_clist_clear(GTK_CLIST(file_clist->clist));
			gtk_clist_thaw(GTK_CLIST(file_clist->clist));
			gtk_widget_destroy(file_clist->clist);
			
			
			
			gtk_widget_destroy(main_window);
			gtk_widget_destroy(GTK_WIDGET(widget));
			break;
		}
		case 1:{	/*button_cancel*/
			gtk_widget_destroy(GTK_WIDGET(widget));
			break;
		}
	}
}


void destroy_cb(GtkWidget *widgete,gchar *data)
{
	GtkWidget *dialog;
	GtkWidget *label;
	gint i ,rows;
	GList *p;
	FileData *file_data;
	
/*	ƥब򤵤ƤȥॢȤưƤޤäƤ
	֤ˤ뤳ȤǥॢȤưߤ	*/
	gtk_clist_freeze (GTK_CLIST (file_clist->clist));
	p = GTK_CLIST(file_clist->clist)->selection;
	while (p != NULL) {
		file_data = (FileData *) gtk_clist_get_row_data (GTK_CLIST (file_clist->clist), (gint) p->data);
		
		gtk_clist_unselect_row (GTK_CLIST(file_clist->clist), 
									gtk_clist_find_row_from_data(GTK_CLIST(file_clist->clist), file_data) ,0);
		p = p->next;
	}
	gtk_clist_thaw(GTK_CLIST(file_clist->clist));
			
	
		dialog = gnome_dialog_new("λǧɥ",
								GNOME_STOCK_BUTTON_OK,
								GNOME_STOCK_BUTTON_CANCEL,
								NULL);
		gnome_window_icon_set_from_file(GTK_WINDOW(dialog),"/usr/share/pixmaps/gikodown.png");
		gtk_window_set_modal(GTK_WINDOW(dialog),TRUE);
		gtk_signal_connect(GTK_OBJECT(dialog),"clicked",
								GTK_SIGNAL_FUNC(dialog_clicked_cb),(gpointer)dialog);



		label = gtk_label_new(" \n"\
							"( ߧ)\n"\
							"λƤ");
		gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),label,FALSE,FALSE,1);
		gtk_widget_show(label);
		gnome_dialog_run_and_close(GNOME_DIALOG(dialog));
	
}


void CreateMainWindow()
{
	
/***	ᥤ󥦥ɥΥå		***/
	GtkWidget *vbox;
	
	
	GtkWidget *scroll_window2;
	
	

	gchar *geometry;
	gint xpos, ypos, width, height;

	/*	ɥΥե	*/
	gnome_config_push_prefix("giko_download/Display/");
	geometry = gnome_config_get_string("geometry=640x500");
	gnome_config_pop_prefix();

	main_window = gnome_app_new("giko"," ǭ ");
	gtk_widget_realize(GTK_WIDGET(main_window));
/*	gtk_widget_set_usize(GTK_WIDGET(main_window),630,500);	*/
	
/*	ɥΰ֤礭	*/
	gtk_window_set_policy (GTK_WINDOW (main_window), FALSE, TRUE, FALSE);
	gnome_parse_geometry (geometry, &xpos, &ypos, &width, &height);
	gtk_widget_set_uposition (main_window, xpos, ypos);
	gtk_window_set_default_size(GTK_WINDOW(main_window),width,height);
	gnome_window_icon_set_from_file(GTK_WINDOW(main_window),"/usr/share/pixmaps/gikodown.png");

	vbox = gtk_vbox_new(FALSE,1);	
	gnome_app_set_contents(GNOME_APP(main_window),vbox);
	gtk_widget_show(vbox);

	create_menu(main_window,vbox);
	create_toolbar(main_window,vbox);

	

	scroll_window = gtk_scrolled_window_new(NULL,NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll_window),
								GTK_POLICY_AUTOMATIC,
								GTK_POLICY_ALWAYS);
/*	gtk_widget_set_usize(GTK_WIDGET(scroll_window),-1,400);	*/

	file_clist_create(scroll_window);
	
	/*gtk_paned_add1(GTK_PANED(vpaned),scroll_window);*/
	gtk_box_pack_start(GTK_BOX(vbox),scroll_window,TRUE,TRUE,3);
	gtk_widget_show(scroll_window);
	

	scroll_window2 = gtk_scrolled_window_new(NULL,NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll_window2),
								GTK_POLICY_AUTOMATIC,
								GTK_POLICY_ALWAYS);
	/*gtk_paned_add2(GTK_PANED(vpaned),scroll_window2);*/
	gtk_box_pack_start(GTK_BOX(vbox),scroll_window2,FALSE,FALSE,3);
	gtk_widget_set_usize(GTK_WIDGET(scroll_window2),-1,120);
	gtk_widget_show(scroll_window2);

	log_create(scroll_window2);

	gtk_signal_connect(GTK_OBJECT(main_window),"delete_event",
					GTK_SIGNAL_FUNC(destroy_cb),NULL);

	
/*	åץС	*/
	appbar_create(vbox);
	appbar_timeout = gtk_timeout_add(600 ,(GtkFunction)appbar_update ,NULL);
	
	gtk_widget_show(main_window);
}


