/* ǭ
 *  Copyright (C) 2000,2001 gchar
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include<gnome.h>
#include<time.h>
#include"giko_download.h"

GtkWidget *log_text;
GdkColor log_color;

gchar *
time_date()
{
	
	struct tm *tm_ptr;
	time_t the_time;

	time(&the_time);
	tm_ptr = localtime(&the_time);

	return g_strdup_printf("%d%d  %d%dʬ%d\n",
								tm_ptr->tm_mon+1,tm_ptr->tm_mday,
								tm_ptr->tm_hour,tm_ptr->tm_min,tm_ptr->tm_sec);
}
	

void
log_completed_show(gchar	*filename)
{
	gchar 	*message_buf;

	/*   */
	log_color.red = 13107;
	log_color.green = 47840;
	log_color.blue = 00000;
	
	message_buf = g_strdup_printf("%s\t%sΥɴλ\n",time_date(),filename);
	gtk_text_insert(GTK_TEXT(log_text),
				NULL,&log_color,NULL,
				message_buf,-1);
	g_free(message_buf);
}

void
log_start_show(gchar *filename)
{
	gchar	*message_buf;

	/*   */
	log_color.red = 32112;
	log_color.green = 29490;
	log_color.blue = 64224;
	
	message_buf = g_strdup_printf("%s\t%s Υɤ򳫻\n",time_date(),filename);
	gtk_text_insert(GTK_TEXT(log_text),
				NULL,&log_color,NULL,
				message_buf,-1);

	g_free(message_buf);
}  

void
log_stop_show(gchar *filename)
{
	gchar 	*message_buf;
	
	/*   */
	log_color.red = 62913;
	log_color.green = 52428;
	log_color.blue = 10485;
	
	message_buf = g_strdup_printf("%s\t%s Υɤ\n",time_date(),filename);
	gtk_text_insert(GTK_TEXT(log_text),
				NULL,&log_color,NULL,
				message_buf,-1);

	g_free(message_buf);
}

void
log_restart_show(gchar *filename)
{
	gchar *message_buf;

	/*   */
	log_color.red = 32112;
	log_color.green = 29490;
	log_color.blue = 64224;
	
	message_buf = g_strdup_printf("%s\t%s Υɤľ\n",time_date(),filename);
	gtk_text_insert(GTK_TEXT(log_text),
				NULL,&log_color,NULL,
				message_buf,-1);
	
	g_free(message_buf);
}

void
log_add_show(gchar *filename)
{
	gchar	*message_buf;
	
	/*   */
	log_color.red = 0;
	log_color.green = 0;
	log_color.blue = 0;
	
	message_buf = g_strdup_printf("%s\t%s ɲ\n",time_date(),filename);
	gtk_text_insert(GTK_TEXT(log_text),
				NULL,&log_color,NULL,
				message_buf,-1);

	g_free(message_buf);
}  

void
log_connect_error_show(gchar *error)
{
	gchar	*message_buf;
	
	log_color.red = 64224;
	log_color.green = 9175;
	log_color.blue = 16384;
	
	message_buf = g_strdup_printf("%s",time_date());
	gtk_text_insert(GTK_TEXT(log_text),
				NULL,&log_color,NULL,
				message_buf,-1);
	
	gtk_text_insert(GTK_TEXT(log_text),
				NULL,&log_color,NULL,
				error,-1);
				
	g_free(message_buf);
}
void
log_error_show(gint	error)
{
	gchar	*message_buf;
	
	/*   */
	log_color.red = 64224;
	log_color.green = 9175;
	log_color.blue = 16384;
	
	message_buf = g_strdup_printf("%s\t顼 : ̵URLɲ\n",time_date());
	
	gtk_text_insert(GTK_TEXT(log_text),
				NULL,&log_color,NULL,
				message_buf,-1);

	g_free(message_buf);
}

void
hello_log()
{
	gchar *message_buf;
	struct tm *tm_ptr;
	time_t the_time;

	time(&the_time);
	tm_ptr = localtime(&the_time);

	
	message_buf = g_strdup_printf("ǭ V0.5.6  %d%d  %d%dʬ%d\n",
								tm_ptr->tm_mon+1,tm_ptr->tm_mday,
								tm_ptr->tm_hour,tm_ptr->tm_min,tm_ptr->tm_sec);
	gtk_text_insert(GTK_TEXT(log_text),
				NULL,NULL,NULL,
				message_buf,-1);
	
	g_free(message_buf);
	
	message_buf = g_strdup_printf("   \n"\
										"(=ߦ؎)   礥 %s\n" ,g_get_user_name());
	gtk_text_insert(GTK_TEXT(log_text) ,
				NULL ,NULL ,NULL ,
				message_buf ,-1);
	g_free(message_buf);
}


void
log_create(GtkWidget *scrolled_window2)
{
	

	log_text = gtk_text_new(NULL,NULL);
	gtk_container_add(GTK_CONTAINER(scrolled_window2),log_text);


	hello_log();
	gtk_widget_show(log_text);
}  
