/* ǭ
 *  Copyright (C) 2000,2001 gchar
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include<gnome.h>
#include<applet-widget.h>
#include<libgnomeui/gnome-window-icon.h>
#include<libgnomeui/gnome-appbar.h>
#include<signal.h>
#include"giko_download.h"
#include"file_data.h"
#include"file_clist.h"
#include"giko_property.h"

#define PACKAGE "sample"
#define VERSION "0.0.2"

Giko_Property giko_prop;


/*	ॢȤ˴ؤ륰Хѿ	*/
extern	GikoTray	*giko_tray;
gint	giko_download_flag;
gint	num_download = 0;			/*ߥɤƤ륢ƥο	*/
gint	per_download = 0;			/*ߥɤƤΤΡ	*/
extern	FileClist	*file_clist;


void
load_property()
{
	gboolean	def;
	gchar *homedir;
	homedir = g_get_home_dir();

	gnome_config_push_prefix("/giko_download/Property/");

	/*	*/
	giko_prop.def_directry = gnome_config_get_string_with_default("def_directry",&def);
	if(def){
		giko_prop.def_directry = g_strdup(homedir);
	}
	giko_prop.completed_remove = gnome_config_get_bool("completed_remove=FALSE");
	giko_prop.num_retries = gnome_config_get_int("num_retries=0");
	giko_prop.timeout = gnome_config_get_int("timeout=900");
	giko_prop.passive_ftp = gnome_config_get_bool("passive_ftp=FALSE");
	/*	http	*/
	giko_prop.referer = gnome_config_get_int("referer=0");
	giko_prop.user_agent = gnome_config_get_int("user_agent=0");
	giko_prop.server = gnome_config_get_int("server=0");
/*	g_print("referer = %d\n",giko_prop.referer);	*/

	/*ץ	*/
	giko_prop.use_proxy = gnome_config_get_bool("use_proxy=FALSE");
	giko_prop.proxy_user = gnome_config_get_string_with_default("proxy_user",&def);
	if(def)
		giko_prop.proxy_user = g_strdup("");
	giko_prop.proxy_password = gnome_config_get_string_with_default("proxy_password",&def);
	if(def)
		giko_prop.proxy_password = g_strdup("");
	giko_prop.proxy_http = gnome_config_get_string_with_default("proxy_http",&def);
	if(def)
		giko_prop.proxy_http = g_strdup("");

/*
	g_print("pass = %s\n",giko_prop.proxy_password);
	g_print("http = %s\n",giko_prop.proxy_http);
*/
		
	/*åץܡ*/
	giko_prop.clipboard_html = gnome_config_get_bool("clipboard_html=FALSE");
	giko_prop.clipboard_htm = gnome_config_get_bool("clipboard_htm=FALSE");
	giko_prop.clipboard_png = gnome_config_get_bool("clipboard_png=FALSE");
	giko_prop.clipboard_jpg = gnome_config_get_bool("clipboard_jpg=FALSE");
	giko_prop.clipboard_jpeg = gnome_config_get_bool("clipboard_jpeg=FALSE");
	giko_prop.clipboard_gif = gnome_config_get_bool("clipboard_gif=FALSE");
	giko_prop.clipboard_asp = gnome_config_get_bool("clipboard_asp=FALSE");
	/*	*/
	giko_prop.use_add_beep = gnome_config_get_bool("use_add_beep=FALSE");
	giko_prop.use_error_beep = gnome_config_get_bool("use_error_beep=FALSE");
	giko_prop.use_complete_beep = gnome_config_get_bool("use_complete_beep=FALSE");

	gnome_config_pop_prefix();
	
}

gboolean
tray_timeout_cb()
{
	
	static FileData *file_data;
	static gchar num_buf[10];
	static gchar per_buf[10];
	static gint	list_rows;
	static int	i;

	static glong	total_size;
	static glong	current_size;

	if(giko_download_flag == 0){
		return TRUE;
	}else if(file_clist->clist == NULL){
		return TRUE;
	}

	list_rows = 0;
	total_size = 0;
	current_size = 0;
	num_download = 0;
	per_download = 0;
	file_data = NULL;

/*	num_download ˴ޤޤ
	Ǥ뤳
	ȡ륵ʬäƤ뤳	*/
	list_rows = GTK_CLIST(file_clist->clist)->rows;
	/*g_print("length = %d\n",list_rows);*/
	for(i = 0 ;i < list_rows ; i++){
		file_data = (FileData *)gtk_clist_get_row_data(GTK_CLIST(file_clist->clist),i);
		if(file_data->state == DATA_RETRIEVING
			|| file_data->state == DATA_CONNECTED
			|| file_data->state == DATA_NOT_CONNECTED){
			if(file_data->total_size != 0){
				num_download++;
				total_size += file_data->total_size;
				current_size += file_data->cur_size;

				/*g_print("to %u cu %u \n",total_size ,current_size);*/
/*			g_print("num = %d\n",num_download);	*/
			
				/*per_download += file_data->percent;*/
			}

		}
	}
	if(num_download != 0){
/*		per_download = per_download / num_download;	*/
		per_download = ( current_size * 100 ) / total_size ;
		/*g_print("per %d\n",per_download);*/
	}

	/*	ɿȥѡơΥåץǡ	*/
	sprintf(num_buf ,"%dե",num_download);
	gtk_label_set_text(GTK_LABEL(giko_tray->num_label),num_buf);

	/*per_buf = g_strdup_printf("%d %%" ,per_download);*/
	sprintf(per_buf ,"%d %%" ,per_download);
	gtk_label_set_text(GTK_LABEL(giko_tray->per_label),per_buf);

	return TRUE;
}


void
signal_handler(int signal_num)
{
	g_printerr("Хӡ save and exit\n");
	
	exit(1);
}

int
main(int argc ,char *argv[])
{
	
	gint	tray_time;
	gchar	*buf[1024];

	applet_widget_init("giko_download","0.1",argc ,argv,NULL,0,NULL);
	/*gnome_init(PACKAGE,VERSION,argc ,argv);*/

/*	ǭȥ쥤κ	*/
	create_giko_tray();
	
/*	ץѥƥɤ	*/
	load_property();

/***	Τ		***/
	/*CreateMainWindow();*/

	
	
/*	ʥ	*/
/*	Cntl + C ǸƤФ	*/
	signal (SIGINT, signal_handler);
	
	tray_time = gtk_timeout_add(600 ,(GtkFunction)tray_timeout_cb,NULL);

	/*gtk_main();*/
	applet_widget_gtk_main();
	gtk_timeout_remove(tray_time);

	return 0;
}  
