/* ǭ
 *  Copyright (C) 2000,2001 gchar
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include<gnome.h>
#include"giko_download.h"
#include"file_data.h"
#include"file_clist.h"
GtkWidget *appbar;

extern FileClist *file_clist;

void
appbar_create(GtkWidget *widget)
{
	appbar = gnome_appbar_new(TRUE,TRUE, GNOME_PREFERENCES_ALWAYS);
	/*gnome_appbar_set_default(GNOME_APPBAR(appbar),"filename");*/
	gtk_box_pack_end(GTK_BOX(widget),appbar,FALSE,FALSE,0);
	gtk_widget_show(appbar);
}  

gboolean
appbar_update(gchar *data)
{
	static	GtkWidget *progress;
	static	gint	row;
	static	FileData	*file_data;
	static	GList	*selection;
	
	selection = NULL;
	selection = GTK_CLIST(file_clist->clist)->selection;
	if(selection == NULL){
		gnome_appbar_refresh(GNOME_APPBAR(appbar));
		gnome_appbar_push(GNOME_APPBAR(appbar) ,"");
		
		progress = (GtkWidget *)gnome_appbar_get_progress(GNOME_APPBAR(appbar));
		gtk_progress_set_value(GTK_PROGRESS(progress),0);
		gtk_progress_set_show_text(GTK_PROGRESS(progress) ,FALSE);
		return TRUE;
	}
	row = GPOINTER_TO_INT(selection->data);
	file_data = (FileData *)gtk_clist_get_row_data(GTK_CLIST(file_clist->clist),row);
	
	/*gnome_appbar_refresh(GNOME_APPBAR(appbar));*/
	gnome_appbar_pop(GNOME_APPBAR(appbar));
	gnome_appbar_push(GNOME_APPBAR(appbar), file_data->filename);
	

	progress = (GtkWidget *)gnome_appbar_get_progress(GNOME_APPBAR(appbar));
	gtk_progress_set_format_string(GTK_PROGRESS(progress),"%p %%");
	gtk_progress_set_value(GTK_PROGRESS(progress) ,(gfloat)file_data->percent);
	gtk_progress_set_show_text(GTK_PROGRESS(progress) ,TRUE);

	return TRUE;
}
	
