/* ǭ
 *  Copyright (C) 2000,2001 gchar
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include<gnome.h>
#include"giko_download.h"
#include"file_clist.h"
#include"file_data.h"
#include"pixmap.h"
#include"dialogs.h"
#include"property.h"
#include"menu.h"
#include"appbar.h"

FileClist	*file_clist;
extern	GtkWidget *main_window;
extern	GtkWidget *appbar;
/*gint	appbar_timeout;*/	/*	åץСΥॢȤΥե饰	*/

/* The types of stuff we accept on dnd */
enum {
    TARGET_CLIST = 0,
    TARGET_URL,
    TARGET_NETSCAPE_URL
};

/* File list popup menu */
static GnomeUIInfo menu_popup[] = {
#define MENU_POPUP_REMOVE 0
    GNOMEUIINFO_ITEM ("ꥹȤ", NULL, remove_cb,
			    trash2_xpm),
    GNOMEUIINFO_SEPARATOR,
#define MENU_POPUP_START 2
    GNOMEUIINFO_ITEM("/Ƴ", NULL, download_start,
			    start3_xpm),
#define MENU_POPUP_STOP 3
    GNOMEUIINFO_ITEM ("", NULL, download_stop, 
			    stop_xpm),
#define MENU_POPUP_RESTART 4
    GNOMEUIINFO_ITEM ("ľ", NULL, download_restart, 
			    restart_xpm),
    GNOMEUIINFO_SEPARATOR,
#define MENU_POPUP_PROPERTIES 6
    /*GNOMEUIINFO_MENU_PROPERTIES_ITEM (NULL, property_create),*/
	GNOMEUIINFO_ITEM ("̤Υץѥƥ", NULL, file_property_show, 
			    property2_xpm),
    GNOMEUIINFO_END
};

void
file_clist_set_menu(GtkCList *clist)
{
	FileData *file_data;
	if(clist->selection == NULL){
		gtk_widget_set_sensitive(menu_popup[0].widget ,FALSE);
		gtk_widget_set_sensitive(menu_popup[1].widget ,FALSE);
		gtk_widget_set_sensitive(menu_popup[2].widget ,FALSE);
		gtk_widget_set_sensitive(menu_popup[3].widget ,FALSE);
		gtk_widget_set_sensitive(menu_popup[4].widget ,FALSE);
		gtk_widget_set_sensitive(menu_popup[6].widget ,FALSE);
	}else if(clist->selection->next == NULL){
		gtk_widget_set_sensitive(menu_popup[0].widget,TRUE);
		gtk_widget_set_sensitive(menu_popup[6].widget,TRUE);
		file_data = (FileData *)gtk_clist_get_row_data (clist, (gint) clist->selection->data);
		if(file_data->state == DATA_NOT_STARTED
			|| file_data->state == DATA_NOT_RUNNING
			|| file_data->state == DATA_STOP)
			gtk_widget_set_sensitive(menu_popup[2].widget,TRUE);
		else
			gtk_widget_set_sensitive(menu_popup[2].widget,FALSE);
		if(file_data->state == DATA_CONNECTED
			|| file_data->state == DATA_NOT_CONNECTED
			|| file_data->state == DATA_RETRIEVING)
			gtk_widget_set_sensitive(menu_popup[3].widget ,TRUE);
		else
			gtk_widget_set_sensitive(menu_popup[3].widget ,FALSE);
		if(file_data->state == DATA_NOT_RUNNING
			|| file_data->state == DATA_COMPLETED)
			gtk_widget_set_sensitive(menu_popup[4].widget ,TRUE);
		else
			gtk_widget_set_sensitive(menu_popup[4].widget ,FALSE);
	}
}
	
void
file_clist_set_url(FileData *file_data ,gint row)
{


	gtk_clist_set_text(GTK_CLIST(file_clist->clist) ,row ,CLIST_COL_STATE ,"");
	gtk_clist_set_text(GTK_CLIST(file_clist->clist) ,row ,CLIST_COL_FILE ,file_data->filename);
	gtk_clist_set_text(GTK_CLIST(file_clist->clist) ,row ,CLIST_COL_PER ,"0%");
	gtk_clist_set_text(GTK_CLIST(file_clist->clist) ,row ,CLIST_COL_REM ,"");
	gtk_clist_set_text(GTK_CLIST(file_clist->clist) ,row ,CLIST_COL_SPEED ,"");
	gtk_clist_set_text(GTK_CLIST(file_clist->clist) ,row ,CLIST_COL_CUR_SIZE ,"");
	gtk_clist_set_text(GTK_CLIST(file_clist->clist) ,row ,CLIST_COL_TOTAL_SIZE ,"");
	gtk_clist_set_text(GTK_CLIST(file_clist->clist) ,row ,CLIST_COL_URL ,file_data->url);
}

/*	file_data_set_directryƤФ
	GtkCListΥǥ쥯ȥ򹹿
*/
void
file_clist_set_directry(FileData *file_data)
{
	gint	row;
	
	row = gtk_clist_find_row_from_data(GTK_CLIST(file_clist->clist) ,file_data);
	gtk_clist_set_text(GTK_CLIST(file_clist->clist),row,CLIST_COL_DIR ,file_data->directry);
	
}

/*	CList Υåץ	*/
void
file_clist_update(FileData	*file_data)
{
	gint	row;
	gchar *buffer;
	gchar *cur_buffer;
	gchar *tor_buffer;
	time_t estimated, remain_time;
	guint32 retr_size = 0;

	/*	%	*/
	if(file_data->state == DATA_COMPLETED){
		buffer = g_strdup("100%");
	}else if(file_data->total_size != 0){
/*			g_print("cur size = %d\n",file_data->cur_size);
			g_print("tor size = %d\n",file_data->total_size);*/
			file_data->percent =  (gint) (((gfloat) file_data->cur_size / file_data->total_size)* 100);
			/*buffer = g_strdup_printf ("%d%%", (gint) (((gfloat) file_data->cur_size / file_data->total_size)* 100));*/
			buffer = g_strdup_printf("%d%%",file_data->percent);
/*			g_print("buffer = %s\n",buffer);	*/
	}else{
		file_data->percent = 0;
		buffer = g_strdup("");
	}
		
	row = gtk_clist_find_row_from_data(GTK_CLIST(file_clist->clist),file_data);
	gtk_clist_set_text(GTK_CLIST(file_clist->clist),row,CLIST_COL_PER ,buffer);

	/*	ȡ륵ȸߤΥե륵	*/
	if(file_data->total_size == 0){
		tor_buffer = g_strdup("");
	}else{
		tor_buffer = g_strdup_printf("%dkB\n",(file_data->total_size + 512) / 1024);
	}

	cur_buffer = g_strdup_printf("%dkB\n",(file_data->cur_size + 512) / 1024);
	gtk_clist_set_text(GTK_CLIST(file_clist->clist),row,CLIST_COL_CUR_SIZE,cur_buffer);
	gtk_clist_set_text(GTK_CLIST(file_clist->clist),row,CLIST_COL_TOTAL_SIZE,tor_buffer);
	
	/*	Ĥ֤Υåץǡ	*/
	retr_size = (file_data->cur_size) - (file_data->session_start_size);
   if (file_data->state != DATA_NOT_STARTED
        && file_data->state != DATA_NOT_RUNNING
        && file_data->state != DATA_COMPLETED) {
	if(file_data->total_size != 0	&&	retr_size != 0 )
		estimated =
                (((gfloat) (file_data->total_size
                            - file_data->session_start_size)
                  * file_data->session_elapsed) / retr_size)
                + ((gfloat) (file_data->total_time
                             - file_data->session_elapsed));
        else
            estimated = 0;
    } else {
        if (file_data->total_size != 0 && file_data->cur_size != 0
            && file_data->state != DATA_COMPLETED)
            estimated =
                ((gfloat) file_data->total_size * file_data->total_time)
                / file_data->cur_size;
        else
            estimated = 0;
    }
    if (estimated == 0)
        buffer = g_strdup("");
    else {
        remain_time = estimated - file_data->total_time;
        sprintf (buffer, "%02d:%02d:%02d", (gint)(remain_time / 3600), 
                 (gint)((remain_time % 3600) / 60), (gint)(remain_time % 60));
    }
    gtk_clist_set_text (GTK_CLIST (file_clist->clist), row,
                        CLIST_COL_REM, buffer);
		
	/*	ԡɤΥåץǡ	*/
	if (file_data->total_time != 0) {
		if (file_data->state == DATA_COMPLETED) {
            		if (file_data->total_size != 0)
                		buffer = g_strdup_printf("%.2f kB/s", ((gfloat) file_data->total_size / file_data->total_time) / 1024);
            		else
                		buffer = g_strdup("");
		}
        	else if (file_data->cur_size != 0 && file_data->diff_time != 0)
			/*buffer = g_strdup_printf("%.2f kB/s", ((gfloat) file_data->cur_size / file_data->total_time) / 1024);*/
			buffer = g_strdup_printf("%.2f kB/s", ((gfloat) file_data->diff_size / (glong)file_data->diff_time) / 1024);
        	else
            		/*buffer = g_strdup("");*/
            		buffer = g_strdup_printf("%.2f kB/s", ((gfloat) file_data->cur_size / (glong)file_data->total_time) / 1024);
	} else
        strcpy (buffer, "");
	gtk_clist_set_text(GTK_CLIST(file_clist->clist),row,
				CLIST_COL_SPEED,buffer);

	g_free(buffer);
	g_free(cur_buffer);
	g_free(tor_buffer);
}

int	clist_event(GtkWidget	*widget ,GdkEvent *event,GtkMenu *popup)
{
	

	
	GdkEventButton *button_event = (GdkEventButton *) event;
	

	if (event->type == GDK_BUTTON_PRESS && button_event->button == 3) {
		gtk_menu_popup(popup,NULL,NULL,NULL,NULL,3,button_event->time);
		
		return TRUE;
	}
	return FALSE;
}

void	clist_selected(GtkWidget *widget,gchar *data)
{

	
/*	g_print("selected\n");*/
	/*	˥塼Υåץǡ	*/
	gtk_clist_freeze(GTK_CLIST(file_clist->clist));
	menu_toolbar_set_state((GtkCList *)file_clist->clist);
	file_clist_set_menu((GtkCList *)(file_clist->clist));
	gtk_clist_thaw(GTK_CLIST(file_clist->clist));
	/*	åץСΥåץǡ	*/
/*	selection = GTK_CLIST(file_clist->clist)->selection;
	if(selection == NULL){
		return;
	}
	row = GPOINTER_TO_INT(selection->data);
	file_data = (FileData *)gtk_clist_get_row_data(GTK_CLIST(file_clist->clist),row);
	appbar_timeout = gtk_timeout_add(600 ,(GtkFunction)appbar_update_selected ,file_data);
*/
}

void	clist_unselected(GtkWidget *widget,gchar *data)
{
/*	g_print("unselected\n");*/
	gtk_clist_freeze(GTK_CLIST(file_clist->clist));
	menu_toolbar_set_state((GtkCList *)file_clist->clist);
	file_clist_set_menu((GtkCList *)(file_clist->clist));
	gtk_clist_thaw(GTK_CLIST(file_clist->clist));
/*	appbar_update_unselected(0);
	gtk_timeout_remove(appbar_timeout);*/
	
}

/*	֤Υǭ򥻥å	*/
void
set_giko_state(GtkCList	*clist,gint	row,DataState	state)
{
	GdkBitmap	*mask;
	GdkPixmap 	*pixmap;
	GtkStyle	*style;

	style = gtk_widget_get_style(main_window);
	
	switch(state){
		case DATA_NOT_STARTED:
			pixmap = gdk_pixmap_create_from_xpm_d(main_window->window,&mask,
											&style->bg[GTK_STATE_NORMAL],
											giko_white_xpm);
			break;
		case DATA_NOT_RUNNING:
			pixmap = gdk_pixmap_create_from_xpm_d(main_window->window,&mask,
											&style->bg[GTK_STATE_NORMAL],
											giko_red_xpm);
			break;
		case DATA_COMPLETED:
			pixmap = gdk_pixmap_create_from_xpm_d(main_window->window,&mask,
											&style->bg[GTK_STATE_NORMAL],
											finish2_xpm);
			break;
		
		case DATA_NOT_CONNECTED:
			pixmap = gdk_pixmap_create_from_xpm_d(main_window->window,&mask,
											&style->bg[GTK_STATE_NORMAL],
											giko_green_xpm);
			break;

		case DATA_STOP:
			pixmap = gdk_pixmap_create_from_xpm_d(main_window->window,&mask,
											&style->bg[GTK_STATE_NORMAL],
											giko_yellow_xpm);
			break;
		
		default:
			pixmap = gdk_pixmap_create_from_xpm_d(main_window->window,&mask,
											&style->bg[GTK_STATE_NORMAL],
											giko_blue_xpm);
			break;
	}

	gtk_clist_set_pixmap(GTK_CLIST(clist),
						row,
						CLIST_COL_STATE,
						pixmap,
						mask);
}

void
file_clist_drag_data_received(GtkWidget *widget, GdkDragContext *context,
                              gint x, gint y, GtkSelectionData *selection_data,
                              guint info, guint time)
{
	g_return_if_fail (widget != NULL);
	switch (info) {
        	case TARGET_URL:
		case TARGET_NETSCAPE_URL:
            	/*dialog_add (selection_data->data);*/
		g_print("URL = %s\n",selection_data->data);
		dialog_clipboard_create((gchar *)selection_data->data);
		break;
   	}
	
	
}

void
file_clist_add(FileData	*file_data)
{
	gint	row;
	gchar *clist_item[9];

	clist_item[CLIST_COL_STATE] = "";
	clist_item[CLIST_COL_FILE] = file_data->filename;
	clist_item[CLIST_COL_PER] = "0%";
	clist_item[CLIST_COL_REM] = "";
	clist_item[CLIST_COL_SPEED] = "";
	clist_item[CLIST_COL_CUR_SIZE] = "";
	clist_item[CLIST_COL_TOTAL_SIZE] = "";
	clist_item[CLIST_COL_DIR] = file_data->directry;
	clist_item[CLIST_COL_URL] = file_data->url;
	
	
/*	g_print("cfile = %s\n",file_data->filename);	*/
	row = gtk_clist_append(GTK_CLIST(file_clist->clist),clist_item);
	gtk_clist_set_row_data_full(GTK_CLIST(file_clist->clist),row,file_data ,(GtkDestroyNotify) file_data_free);
	set_giko_state((GtkCList *)file_clist->clist ,row	,DATA_NOT_STARTED);
}

void
file_clist_remove_file()
{
	GList *p;
	FileData *file_data;

	gtk_clist_freeze (GTK_CLIST (file_clist->clist));
	p = GTK_CLIST(file_clist->clist)->selection;
	while (p != NULL) {
		file_data = (FileData *) gtk_clist_get_row_data (GTK_CLIST (file_clist->clist), (gint) p->data);
		p = p->next;
		gtk_clist_remove (GTK_CLIST(file_clist->clist), 
									gtk_clist_find_row_from_data(GTK_CLIST(file_clist->clist), file_data));
	}

	gtk_clist_thaw (GTK_CLIST (file_clist->clist));
}

/*	ɴλꥹȤ	*/
void
file_clist_complete_remove_file(gint	row)
{
	gtk_clist_freeze(GTK_CLIST(file_clist->clist));
	gtk_clist_remove(GTK_CLIST(file_clist->clist),row);
	gtk_clist_thaw(GTK_CLIST(file_clist->clist));
}

									
void
file_clist_create(GtkWidget *scrolled_window)
{
	gchar	*titles[9];
	GtkWidget *popup = NULL;

	static GtkTargetEntry target_table[] = {
        { "gtk-clist-drag-reorder", 0, TARGET_CLIST },
        { "text/uri-list", 0, TARGET_URL },
        { "text/plain", 0, TARGET_URL },
        { "x-url/http", 0, TARGET_NETSCAPE_URL },
        { "x-url/ftp", 0, TARGET_NETSCAPE_URL },
        { "_NETSCAPE_URL", 0, TARGET_NETSCAPE_URL }
    };
	
	titles[CLIST_COL_STATE] = "";
	titles[CLIST_COL_FILE] = "    ե̾     ";
	titles[CLIST_COL_PER] = "    %    ";
	titles[CLIST_COL_REM] = " Ĥ ";
	titles[CLIST_COL_SPEED] = "    ®     ";
	titles[CLIST_COL_CUR_SIZE] = "   ";
	titles[CLIST_COL_TOTAL_SIZE] = "      ";
	titles[CLIST_COL_DIR] = "     ¸      ";
	titles[CLIST_COL_URL] = "URL";
	

	file_clist = g_new(FileClist,1);
	file_clist->clist = gtk_clist_new_with_titles(9,titles);
	gtk_clist_set_selection_mode(GTK_CLIST(file_clist->clist),
								GTK_SELECTION_SINGLE);
	gtk_clist_set_shadow_type(GTK_CLIST(file_clist->clist),GTK_SHADOW_IN);
	gtk_clist_set_reorderable(GTK_CLIST(file_clist->clist),TRUE);
	gtk_clist_set_use_drag_icons(GTK_CLIST(file_clist->clist),FALSE);
	gtk_clist_column_titles_passive(GTK_CLIST(file_clist->clist));
	gtk_container_add(GTK_CONTAINER(scrolled_window),file_clist->clist);

/*	⤵	*/
	gtk_clist_set_column_auto_resize(GTK_CLIST(file_clist->clist),CLIST_COL_STATE,TRUE);
	gtk_clist_set_column_auto_resize(GTK_CLIST(file_clist->clist),CLIST_COL_FILE,TRUE);
	gtk_clist_set_column_auto_resize(GTK_CLIST(file_clist->clist),CLIST_COL_PER,TRUE);
	gtk_clist_set_column_auto_resize(GTK_CLIST(file_clist->clist),CLIST_COL_REM,TRUE);
	gtk_clist_set_column_auto_resize(GTK_CLIST(file_clist->clist),CLIST_COL_SPEED,TRUE);
	gtk_clist_set_column_auto_resize(GTK_CLIST(file_clist->clist),CLIST_COL_CUR_SIZE,TRUE);
	gtk_clist_set_column_auto_resize(GTK_CLIST(file_clist->clist),CLIST_COL_TOTAL_SIZE,TRUE);
	gtk_clist_set_column_auto_resize(GTK_CLIST(file_clist->clist),CLIST_COL_DIR,TRUE);
	gtk_clist_set_column_auto_resize(GTK_CLIST(file_clist->clist),CLIST_COL_URL,TRUE);
	
	gtk_clist_set_row_height(GTK_CLIST(file_clist->clist),18);

	popup = gnome_popup_menu_new (menu_popup);

	gtk_signal_connect(GTK_OBJECT(file_clist->clist),"event",	
					GTK_SIGNAL_FUNC(clist_event),popup);
	gtk_signal_connect(GTK_OBJECT(file_clist->clist),"select_row",
					GTK_SIGNAL_FUNC(clist_selected),NULL);
	gtk_signal_connect(GTK_OBJECT(file_clist->clist),"unselect_row",
					GTK_SIGNAL_FUNC(clist_unselected),NULL);

	/*	ɥå&ɥåפ	*/
	gtk_drag_dest_unset (file_clist->clist);
	gtk_drag_dest_set (file_clist->clist, 
				GTK_DEST_DEFAULT_MOTION  | GTK_DEST_DEFAULT_DROP,
                       target_table, 
		       sizeof (target_table) / sizeof (target_table[0]),
                      	GDK_ACTION_COPY | GDK_ACTION_MOVE);

	gtk_signal_connect (GTK_OBJECT (file_clist->clist), "drag_data_received",
                        GTK_SIGNAL_FUNC(file_clist_drag_data_received), NULL);
	gtk_widget_show(file_clist->clist);
}  
