/* ǭ
 *  Copyright (C) 2000,2001 gchar
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include<gnome.h>
#include<libgnomeui/gnome-window-icon.h>
#include"giko_download.h"
#include"property.h"
/*#include"DialogNew.h"*/
#include"file_clist.h"
#include"file_data.h"
#include"pixmap.h"
#include"dialogs.h"
#include"log.h"
#include"menu.h"
#include"file_property.h"
#include"giko_property.h"


extern	FileClist	*file_clist;
extern gboolean clipboard_show_flag;
extern Giko_Property	giko_prop;
/*ץȥ*/
void private_cb();

GtkWidget *start_button;
GtkWidget *stop_button;
GtkWidget *restart_button;
GtkWidget *remove_button;
GtkWidget *property2_button;
GtkWidget *new_paste;
GtkWidget *menu_start ,*menu_stop ,*menu_restart ,*menu_trash ,*menu_property2;

/***	ե̾ФCLIST˥ƥɲä롣	***/
void list_ok_cb(GtkWidget *widget,gpointer list_fs)
{
	gchar *filename;
	
	
	
	gtk_widget_hide(GTK_WIDGET(list_fs));
	filename = gtk_file_selection_get_filename(GTK_FILE_SELECTION(list_fs));
	
	g_print("filename = %s\n",filename);
	
}

void list_hide_cb(GtkWidget *widget,gpointer list_fs)
{
	gtk_widget_hide(GTK_WIDGET(list_fs));
}

/***	URLꥹȤ򤹤ե륻쥯	***/
void open_url_list()
{
	GtkWidget *list_fs;

	list_fs = gtk_file_selection_new("URLꥹȤ򳫤");
	gnome_window_icon_set_from_file(GTK_WINDOW(list_fs),"giko6.png");
	gtk_window_set_modal(GTK_WINDOW(list_fs),TRUE);

/***	OKܥ	***/
	gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(list_fs)->ok_button),"clicked",
					GTK_SIGNAL_FUNC(list_ok_cb),(gpointer)list_fs);

/***	󥻥ܥ	***/
	gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(list_fs)->cancel_button),"clicked",
					GTK_SIGNAL_FUNC(list_hide_cb),(gpointer)list_fs);
	gtk_widget_show(list_fs);
}


void clear_cb(GtkWidget *widget ,gpointer url_entry)
{
	gtk_entry_set_text(GTK_ENTRY(url_entry),"");
}


void download_start()
{
	GList *selection;
	gint row ,rows;
	FileData 	*file_data;

	gtk_clist_freeze(GTK_CLIST(file_clist->clist));
	selection = GTK_CLIST(file_clist->clist)->selection;
	if(selection == NULL){
		gtk_clist_thaw(GTK_CLIST(file_clist->clist));
		return;
	}
	row = GPOINTER_TO_INT(selection->data);
	file_data = (FileData *)gtk_clist_get_row_data(GTK_CLIST(file_clist->clist),row);
	gtk_clist_thaw(GTK_CLIST(file_clist->clist));
/*	g_print("filename = %s\n",file_data->filename);
	g_print("url = %s\n",file_data->url);
	g_print("dir = %s\n",file_data->directry);
*/	
	file_data_start_download(file_data);
	log_start_show(file_data->filename);
	
/*	ȤǼΥƥեˤ	*/
	rows = GTK_CLIST(file_clist->clist)->rows;
	if(rows > row + 1)
		gtk_clist_select_row(GTK_CLIST(file_clist->clist) ,row + 1 ,0);
/*	g_print("row = %d\n",row);
	g_print("rows = %d\n",rows);*/
	return;
}

void
download_stop()
{
	gint	row;
	GList	*selection;
	FileData *file_data;

	gtk_clist_freeze(GTK_CLIST(file_clist->clist));
	selection = GTK_CLIST(file_clist->clist)->selection;
	if(selection == NULL){
		gtk_clist_thaw(GTK_CLIST(file_clist->clist));
		return;
	}
	row = GPOINTER_TO_INT(selection->data);
	file_data = (FileData *)gtk_clist_get_row_data(GTK_CLIST(file_clist->clist),row);
	gtk_clist_thaw(GTK_CLIST(file_clist->clist));

	file_data_stop_download(file_data);
	log_stop_show(file_data->filename);

}

void
download_restart()
{
	gint	row;
	GList	*selection;
	FileData	*file_data;

	gtk_clist_freeze(GTK_CLIST(file_clist->clist));
	selection = GTK_CLIST(file_clist->clist)->selection;
	if(selection == NULL){
		gtk_clist_thaw(GTK_CLIST(file_clist->clist));
		return ;
	}
	row = GPOINTER_TO_INT(selection->data);
	file_data = (FileData *)gtk_clist_get_row_data(GTK_CLIST(file_clist->clist),row);
	gtk_clist_thaw(GTK_CLIST(file_clist->clist));

	file_data_restart_download(file_data);
	log_restart_show(file_data->filename);
}

/*	ƥ	*/

void remove_cb()
{
	FileData	*file_data;
	GList *selection;
	gint row ,rows;

	
	selection = GTK_CLIST(file_clist->clist)->selection;
	if(selection == NULL){
		
		return;
	}

	row = GPOINTER_TO_INT(selection->data);
	file_data = (FileData *)gtk_clist_get_row_data(GTK_CLIST(file_clist->clist),row);

/*	ե뤬ɴλʤ̵Ǻ
	ǤʤСɥ򳫤	*/
	if(file_data->state == DATA_COMPLETED)
		file_clist_remove_file();
	else
		dialog_remove(file_data);
	
/*	rowեˤ	˥ƥबϼΥƥե
	 ǸΥƥϰΥƥե*/
	rows = GTK_CLIST(file_clist->clist)->rows;
	if(rows > row )
		gtk_clist_select_row(GTK_CLIST(file_clist->clist) ,row ,0);
	else if(rows == row)
		gtk_clist_select_row(GTK_CLIST(file_clist->clist) ,row -1 ,0);
	
	
}


void dialog_new_show()
{
	
	dialog_new_create();
}

/*̵뤹ĥҤξTRUE֤*/
gboolean
check_extention(gchar *extention)
{
	/*g_print("ext = %s\n",extention);*/
	if(giko_prop.clipboard_html == TRUE){
		if(strstr(extention ,"html") != NULL)
			return TRUE;
	}
	
	if(giko_prop.clipboard_htm == TRUE){
		if(strstr(extention ,"htm") != NULL && strstr(extention ,"html") == NULL)
			return TRUE;
	}
	
	if(giko_prop.clipboard_png == TRUE){
		if(strstr(extention ,"png") != NULL)
			return TRUE;
	}
	
	if(giko_prop.clipboard_jpg == TRUE){
		if(strstr(extention ,"jpg") != NULL)
			return TRUE;
	}
	
	if(giko_prop.clipboard_jpeg == TRUE){
		if(strstr(extention ,"jpeg") != NULL)
			return TRUE;
	}
	
	if(giko_prop.clipboard_gif == TRUE){
		if(strstr(extention ,"gif") != NULL)
			return TRUE;
	}
	
	if(giko_prop.clipboard_asp == TRUE){
		if(strstr(extention ,"asp") != NULL)
			return TRUE;
	}
	return FALSE;
}		

/*	åץܡɤ˴ؤؿ	*/
/*	쥯Υ塼ȥꥢɤǤǤ()	*/
/*	Ariaȴ	*/
gboolean Paste_get_clipboard(GtkWidget *widget,gchar *data)
{
	
	
  static GdkAtom targets_atom = GDK_NONE;

 /* ʸ "STRING" б륢ȥ	*/
  if (targets_atom == GDK_NONE)
    targets_atom = gdk_atom_intern ("STRING", FALSE);

  /* ץ饤ޥꥻ쥯 "STRING" åȤ׵	*/
  gtk_selection_convert (widget, GDK_SELECTION_PRIMARY, targets_atom,
			 GDK_CURRENT_TIME);
  
	return TRUE;
}

/*	åץܡɤ˴ؤؿ	*/
gboolean Paste_selection_received(GtkWidget *widget, GtkSelectionData *selection_data, gpointer data)
{
	gchar *clipboard_contents;
	gchar *extention;

	
	if (selection_data->length < 0) {
	      return TRUE;
  	}

	if (selection_data->type != GDK_SELECTION_TYPE_STRING) {
	    return TRUE;
  	}

	clipboard_contents = g_strdup(selection_data->data);
	/*ζ*/
	clipboard_contents = g_strchug(clipboard_contents);
	clipboard_contents = g_strchomp(clipboard_contents);
	
	
	/*ĥҤޤǤʤС̵뤹*/
	extention = strrchr(clipboard_contents ,'.');
	if(extention == NULL){
		g_free(clipboard_contents);
		return TRUE;
	}
	
	/*̵뤹ĥҤå*/
	if(check_extention(extention) == TRUE)
		return TRUE;

	/*⤷ɥ쥹ttpǻϤޤʤhǽդ*/
	if(!strncasecmp(clipboard_contents ,"ttp",3))
		clipboard_contents = g_strconcat("h",clipboard_contents ,NULL);

	/*g_print("clickboard = %s\n",clipboard_contents);*/

/*	g_print("show_flag = %d\n",clipboard_show_flag);	*/
	if(clipboard_show_flag == FALSE){
		clipboard_show_flag = TRUE;
		dialog_clipboard_create(clipboard_contents);
		
		
	}else{
		/*dialog_clipboard_create(clipboard_contents);	*/
		g_free(clipboard_contents);
		return TRUE;
	}
	g_free(clipboard_contents);
	return TRUE;
}

/*	˥塼ƥѤΥåץܡ	*/

void menu_paste_clipboard(GtkWidget *widget,gchar *data)
{

	/*
	gtk_signal_connect(GTK_OBJECT(GTK_MENU_ITEM(widget)),"activate",
					GTK_SIGNAL_FUNC(dialog_clipboard_activate),NULL);
	

	gtk_signal_connect(GTK_OBJECT(widget),"selection_received",
					GTK_SIGNAL_FUNC(dialog_clipboard_received),NULL);
	*/
		
}


/*	ϥġСѤΥåץܡ	*/
void toolbar_paste_clipboard(GtkWidget *widget,gchar *data)
{
	/*
	gtk_signal_connect(GTK_OBJECT(widget),"clicked",
					GTK_SIGNAL_FUNC(dialog_clipboard_activate),NULL);

	gtk_signal_connect(GTK_OBJECT(widget),"selection_received",
					GTK_SIGNAL_FUNC(dialog_clipboard_received),NULL);
	*/
}

void
file_property_show()
{
	FileData *file_data;
	GList *selection;
	gint	row;

	selection = GTK_CLIST(file_clist->clist)->selection;
	if(selection == NULL){
		
		return;
	}

	row = GPOINTER_TO_INT(selection->data);
	file_data = (FileData *)gtk_clist_get_row_data(GTK_CLIST(file_clist->clist),row);

	file_property_create(file_data);
}


/*	ľ˰ư	*/
void move_up()
{
	GList *selection;
	gint row;

	gtk_clist_freeze(GTK_CLIST(file_clist->clist));
	selection = GTK_CLIST(file_clist->clist)->selection;
	if(selection == NULL){
		gtk_clist_thaw(GTK_CLIST(file_clist->clist));

		return;
	}
	row = GPOINTER_TO_INT(selection->data);
	gtk_clist_select_row(GTK_CLIST(file_clist->clist),row-1,0);
	gtk_clist_thaw(GTK_CLIST(file_clist->clist));

}

/*	Ĳ˰ư	*/
void move_down()
{

	GList *selection;
	gint row;
	
	gtk_clist_freeze(GTK_CLIST(file_clist->clist));
	selection = GTK_CLIST(file_clist->clist)->selection;
	if(selection == NULL){
		gtk_clist_thaw(GTK_CLIST(file_clist->clist));
		return;
	}
	row = GPOINTER_TO_INT(selection->data);
	gtk_clist_select_row(GTK_CLIST(file_clist->clist),row+1,0);
	gtk_clist_thaw(GTK_CLIST(file_clist->clist));

}


GnomeUIInfo main_toolbar[] = {

GNOMEUIINFO_ITEM(NULL, 
               "ƥɲ(URL)",
                   (gpointer)dialog_new_show , new_url_xpm),


GNOMEUIINFO_ITEM(NULL, 
              "ƥɲ(åץܡ)",
                    (gpointer)toolbar_paste_clipboard, new_paste_xpm),

GNOMEUIINFO_ITEM(NULL, 
               "URLꥹȤ򳫤",
                    (gpointer)open_url_list, new_file_xpm),




GNOMEUIINFO_SEPARATOR,

GNOMEUIINFO_ITEM(NULL, 
               "/Ƴ",
                   (gpointer)download_start, start_xpm),

GNOMEUIINFO_ITEM(NULL, 
               "",
                    NULL, stop_xpm),

GNOMEUIINFO_ITEM(NULL, 
              "ľ" ,
                    NULL, restart_xpm),


GNOMEUIINFO_ITEM(NULL, 
               "",
                    NULL, trash2_xpm),

GNOMEUIINFO_SEPARATOR,


GNOMEUIINFO_ITEM(NULL, 
               "ǥեȤΥץѥƥ",
                    (gpointer)property_create, property_xpm),


GNOMEUIINFO_ITEM(NULL, 
               "򤵤줿ƥΥץѥƥ",
                    (gpointer)private_cb, property2_xpm),

GNOMEUIINFO_SEPARATOR,

GNOMEUIINFO_ITEM(NULL, 
               "˰ư",
                    (gpointer)move_up, up_xpm),


GNOMEUIINFO_ITEM(NULL, 
               "˰ư",
                    (gpointer)move_down, down_xpm),
GNOMEUIINFO_END
};

void
private_clicked(GtkWidget *w,gchar *data)
{
	g_print("click\n");
}

void
private_cb()
{
	gtk_signal_connect(GTK_OBJECT(main_toolbar[7].widget),"activate",
						GTK_SIGNAL_FUNC(private_clicked),NULL);
}

/*ե˥塼*/
static GnomeUIInfo file_menu[] = {


{
GNOME_APP_UI_ITEM,
"ƥɲ",
NULL,
(gpointer)dialog_new_show,
NULL,NULL,
GNOME_APP_PIXMAP_DATA,
new_url_xpm,
'N',
GDK_CONTROL_MASK,
NULL
},


{
GNOME_APP_UI_ITEM,
"ƥɲ(åץܡ)",
NULL,
(gpointer)menu_paste_clipboard,
NULL,NULL,
GNOME_APP_PIXMAP_DATA, 
new_paste_xpm,
'A',
GDK_CONTROL_MASK,
NULL
},


{
GNOME_APP_UI_ITEM,
"URLꥹȤ򳫤",
NULL,
(gpointer)open_url_list,
NULL,NULL,
GNOME_APP_PIXMAP_DATA,
new_file_xpm,
'O',
GDK_CONTROL_MASK,
NULL
},

{
GNOME_APP_UI_ITEM,
"λ",
 NULL,
(gpointer)destroy_cb,
 NULL, 
NULL,
GNOME_APP_PIXMAP_STOCK , 
GNOME_STOCK_MENU_QUIT,
'Q',
 GDK_CONTROL_MASK, 
NULL
},
GNOMEUIINFO_END
};


/*ɥ˥塼*/
static GnomeUIInfo download_menu[] = {
{
GNOME_APP_UI_ITEM,
"/Ƴ",
 NULL,
(gpointer)download_start,
 NULL, 
NULL,
GNOME_APP_PIXMAP_DATA, 
start_xpm,
'Q',
 GDK_CONTROL_MASK, 
NULL
},

{
GNOME_APP_UI_ITEM,
"",
 NULL,
(gpointer)gtk_main_quit,
 NULL, 
NULL,
GNOME_APP_PIXMAP_DATA, 
stop_xpm,
'Q',
 GDK_CONTROL_MASK, 
NULL
},


{
GNOME_APP_UI_ITEM,
"ɤľ",
 NULL,
(gpointer)gtk_main_quit,
 NULL, 
NULL,
GNOME_APP_PIXMAP_DATA, 
restart_xpm,
'Q',
 GDK_CONTROL_MASK, 
NULL
},

{
GNOME_APP_UI_ITEM,
"",
 NULL,
NULL,
 NULL, 
NULL,
GNOME_APP_PIXMAP_DATA, 
trash2_xpm,
'Q',
 GDK_CONTROL_MASK, 
NULL
},
GNOMEUIINFO_SEPARATOR,


{
GNOME_APP_UI_ITEM,
"ľ˰ư",
 NULL,
(gpointer)move_up,
 NULL, 
NULL,
GNOME_APP_PIXMAP_DATA, 
up_xpm,
'Q',
 GDK_CONTROL_MASK, 
NULL
},


{
GNOME_APP_UI_ITEM,
"Ĳ˰ư",
 NULL,
(gpointer)move_down,
 NULL, 
NULL,
GNOME_APP_PIXMAP_DATA, 
down_xpm,
'Q',
 GDK_CONTROL_MASK, 
NULL
},

GNOMEUIINFO_END
};


/*	˥塼	*/
static GnomeUIInfo option_menu[] = {
{
GNOME_APP_UI_ITEM,
"ץѥƥ",
 NULL,
(gpointer)property_create,
 NULL, 
NULL,
GNOME_APP_PIXMAP_DATA, 
property_xpm,
'Q',
 GDK_CONTROL_MASK, 
NULL
},

{
GNOME_APP_UI_ITEM,
"򤵤줿ƥΥץѥƥ",
 NULL,
(gpointer)open_url_list,
 NULL, 
NULL,
GNOME_APP_PIXMAP_DATA, 
property2_xpm,
'Q',
 GDK_CONTROL_MASK, 
NULL
},

GNOMEUIINFO_END
};
/*إץ˥塼*/
static GnomeUIInfo help_menu[] = {
{GNOME_APP_UI_ITEM, 
"", 
NULL,
(gpointer)my_about_cb,
 NULL,
 NULL, 
GNOME_APP_PIXMAP_STOCK,
 GNOME_STOCK_MENU_ABOUT,
'Q', 
GDK_CONTROL_MASK, 
NULL},
/*顼ФGNOMEUIINFO_SEPARATOR,*/
/*GNOMEUIINFO_HELP("help-browser"),*/
GNOMEUIINFO_END
};

/*	˥塼	*/
static GnomeUIInfo main_menu[] = { 
		GNOMEUIINFO_SUBTREE("ե",file_menu),
		GNOMEUIINFO_SUBTREE("",download_menu),
		GNOMEUIINFO_SUBTREE("",option_menu),
		GNOMEUIINFO_SUBTREE("إ",help_menu),
		GNOMEUIINFO_END
};


void
create_menu(GtkWidget *window ,GtkWidget *vbox)
{
	GtkWidget *menu_bar;
	GtkWidget *file_menu ,*download_menu ,*option_menu ,*help_menu;
	GtkWidget *file_item ,*download_item ,*option_item ,*help_item;
	GtkWidget *new_url ,*exit;												 /*ե	*/
	GtkWidget *menu_property ,*menu_up ,*menu_down;	/*	ץ	*/
	GtkWidget *sep_menu ,*menu_about;
	GtkAccelGroup *accel_group;	/*	硼ȥå	*/

	menu_bar = gtk_menu_bar_new();
	gtk_box_pack_start(GTK_BOX(vbox),menu_bar,FALSE,FALSE,0);
	gtk_widget_show(menu_bar);


/***	ե	***/
	file_menu = gtk_menu_new();

	new_url = gtk_menu_item_new_with_label("ƥɲ(URL)");
	gtk_menu_append(GTK_MENU(file_menu), new_url);
	gtk_signal_connect(GTK_OBJECT(new_url), "activate",
		     GTK_SIGNAL_FUNC(dialog_new_show), NULL);
	gtk_widget_show(new_url);

	new_paste = gtk_menu_item_new_with_label("ƥɲ(ڡ)");
	gtk_menu_append(GTK_MENU(file_menu), new_paste);
	gtk_signal_connect(GTK_OBJECT(new_paste), "activate",
		     GTK_SIGNAL_FUNC(Paste_get_clipboard), NULL);
	gtk_signal_connect(GTK_OBJECT(new_paste), "selection_received",
		       GTK_SIGNAL_FUNC(Paste_selection_received),
		       NULL);
	gtk_widget_show(new_paste);

	sep_menu = gtk_menu_item_new();
	gtk_menu_append(GTK_MENU(file_menu), sep_menu);
	gtk_widget_show(sep_menu);

	exit = gtk_menu_item_new_with_label("λ");
	gtk_menu_append(GTK_MENU(file_menu), exit);
	gtk_signal_connect(GTK_OBJECT(exit), "activate",
		     GTK_SIGNAL_FUNC(destroy_cb), NULL);
	gtk_widget_show(exit);


	file_item = gtk_menu_item_new_with_label("ե");
  	gtk_widget_show(file_item);
  	gtk_menu_item_set_submenu(GTK_MENU_ITEM(file_item), file_menu);
  	gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), file_item);


/***		***/
	download_menu = gtk_menu_new();

	menu_start = gtk_menu_item_new_with_label("ɤγ/Ƴ");
	gtk_menu_append(GTK_MENU(download_menu), menu_start);
	gtk_signal_connect(GTK_OBJECT(menu_start), "activate",
		     GTK_SIGNAL_FUNC(download_start), NULL);
	gtk_widget_show(menu_start);

	menu_stop = gtk_menu_item_new_with_label("ɤ");
	gtk_menu_append(GTK_MENU(download_menu), menu_stop);
	gtk_signal_connect(GTK_OBJECT(menu_stop), "activate",
		     GTK_SIGNAL_FUNC(download_stop), NULL);
	gtk_widget_show(menu_stop);
	
	menu_restart = gtk_menu_item_new_with_label("ɤΤľ");
	gtk_menu_append(GTK_MENU(download_menu), menu_restart);
	gtk_signal_connect(GTK_OBJECT(exit), "activate",
		     GTK_SIGNAL_FUNC(download_restart), NULL);
	gtk_widget_show(menu_restart);

	menu_trash = gtk_menu_item_new_with_label("ꥹȤ");
	gtk_menu_append(GTK_MENU(download_menu), menu_trash);
	gtk_signal_connect(GTK_OBJECT(menu_trash), "activate",
		     GTK_SIGNAL_FUNC(remove_cb), NULL);
	gtk_widget_show(menu_trash);

	download_item = gtk_menu_item_new_with_label("");
  	gtk_widget_show(download_item);
  	gtk_menu_item_set_submenu(GTK_MENU_ITEM(download_item), download_menu);
  	gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), download_item);


/***	ץ	***/
	option_menu = gtk_menu_new();
	
	menu_property = gtk_menu_item_new_with_label("ΤΥץѥƥ");
	gtk_menu_append(GTK_MENU(option_menu), menu_property);
	gtk_signal_connect(GTK_OBJECT(menu_property), "activate",
		     GTK_SIGNAL_FUNC(property_create), NULL);
	gtk_widget_show(menu_property);

	
	menu_property2 = gtk_menu_item_new_with_label("̤Υץѥƥ");
	gtk_menu_append(GTK_MENU(option_menu), menu_property2);
	gtk_signal_connect(GTK_OBJECT(menu_property2), "activate",
		     GTK_SIGNAL_FUNC(file_property_show), NULL);
	gtk_widget_show(menu_property2);
	
	
	sep_menu = gtk_menu_item_new();
	gtk_menu_append(GTK_MENU(option_menu), sep_menu);
	gtk_widget_show(sep_menu);

	
	menu_up = gtk_menu_item_new_with_label("ľ˰ư");
	gtk_menu_append(GTK_MENU(option_menu), menu_up);
	gtk_signal_connect(GTK_OBJECT(menu_up), "activate",
		     GTK_SIGNAL_FUNC(move_up), NULL);
	gtk_widget_show(menu_up);

	menu_down = gtk_menu_item_new_with_label("Ĳ˰ư");
	gtk_menu_append(GTK_MENU(option_menu), menu_down);
	gtk_signal_connect(GTK_OBJECT(menu_down), "activate",
		     GTK_SIGNAL_FUNC(move_down), NULL);
	gtk_widget_show(menu_down);

	option_item = gtk_menu_item_new_with_label("ץ");
  	gtk_widget_show(option_item);
  	gtk_menu_item_set_submenu(GTK_MENU_ITEM(option_item), option_menu);
  	gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), option_item);

	

/***	إ	*/
	help_menu = gtk_menu_new();

	
	menu_about = gtk_menu_item_new_with_label("");
	gtk_menu_append(GTK_MENU(help_menu), menu_about);
	gtk_signal_connect(GTK_OBJECT(menu_about), "activate",
		     GTK_SIGNAL_FUNC(my_about_cb), NULL);
	gtk_widget_show(menu_about);
	
	
	help_item = gtk_menu_item_new_with_label("إ");
  	gtk_widget_show(help_item);
  	gtk_menu_item_set_submenu(GTK_MENU_ITEM(help_item), help_menu);
  	gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), help_item);
  	
  	
/*	硼ȥå	*/
	accel_group = gtk_accel_group_new();
	gtk_window_add_accel_group(GTK_WINDOW(window) ,accel_group);
		
	
	gtk_widget_add_accelerator(new_paste ,"activate" ,accel_group ,
										'C' ,GDK_SHIFT_MASK ,TRUE);
										
	gtk_widget_add_accelerator(menu_start ,"activate" ,accel_group ,
										'S' ,GDK_SHIFT_MASK ,TRUE);
										
	gtk_widget_add_accelerator(menu_stop ,"activate" ,accel_group ,
										'F' ,GDK_SHIFT_MASK ,TRUE);
									
	gtk_widget_add_accelerator(menu_restart ,"activate" ,accel_group ,
										'R' ,GDK_SHIFT_MASK ,TRUE);
										
	gtk_widget_add_accelerator(menu_trash ,"activate" ,accel_group ,
										'D' ,GDK_SHIFT_MASK ,TRUE);
										
	gtk_widget_add_accelerator(menu_up ,"activate" ,accel_group ,
										'Q' ,GDK_SHIFT_MASK ,TRUE);
										
	gtk_widget_add_accelerator(menu_down ,"activate" ,accel_group ,
										'A' ,GDK_SHIFT_MASK ,TRUE);
}

void
create_toolbar(GtkWidget *window ,GtkWidget *vbox)
{
	GtkWidget *handle;
	GtkWidget *hbox;
	GtkWidget *toolbar;
	GdkPixmap * icon;
   	GdkBitmap * mask;
   	GtkWidget * iconw;
	GtkWidget *paste_button;

	GtkWidget *giko_button;


	handle = gtk_handle_box_new();
	gtk_box_pack_start(GTK_BOX(vbox),handle,FALSE,FALSE,3);
	gtk_widget_show(handle);
	/*gnome_app_create_menus(GNOME_APP(main_window),main_menu);	*/
	/*gnome_app_create_toolbar(GNOME_APP(main_window),main_toolbar);	*/

	hbox = gtk_hbox_new(FALSE ,2);
	gtk_container_add(GTK_CONTAINER(handle) ,hbox );
	gtk_widget_show(hbox);

	toolbar = gtk_toolbar_new(GTK_ORIENTATION_HORIZONTAL,GTK_TOOLBAR_ICONS);
	gtk_container_set_border_width(GTK_CONTAINER(toolbar), 5);
	gtk_box_pack_start(GTK_BOX(hbox) ,toolbar ,FALSE ,FALSE ,2);
	/*gtk_box_pack_start(GTK_BOX(vbox),toolbar,FALSE,FALSE,3);*/
	gtk_widget_show(toolbar);


	icon = gdk_pixmap_create_from_xpm_d(window->window,
					&mask,
					&window->style->white,
					url_xpm);
    	iconw = gtk_pixmap_new(icon, mask);
	gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),
						"List",
						_("ƥɲ(URL)"),
						"Private",
						iconw,
						GTK_SIGNAL_FUNC(dialog_new_show),
						NULL);

	
	icon = gdk_pixmap_create_from_xpm_d(window->window,
					&mask,
					&window->style->white,
					paste_xpm);
    	iconw = gtk_pixmap_new(icon, mask);
	paste_button = gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),
						"List",
						_("ƥɲ(ڡ) Shift + C"),
						"Private",
						iconw,
						GTK_SIGNAL_FUNC(Paste_get_clipboard),
						NULL);
	gtk_signal_connect(GTK_OBJECT(paste_button), "selection_received",
		       GTK_SIGNAL_FUNC(Paste_selection_received),
		       NULL);
	
	
	gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));

	icon = gdk_pixmap_create_from_xpm_d(window->window,
					&mask,
					&window->style->white,
					start3_xpm);
    	iconw = gtk_pixmap_new(icon, mask);
	start_button = gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),
						"List",
						_("ɳ/Ƴ Shift + S"),
						"Private",
						iconw,
						GTK_SIGNAL_FUNC(download_start),
						NULL);

	
	icon = gdk_pixmap_create_from_xpm_d(window->window,
					&mask,
					&window->style->white,
					stop_xpm);
    	iconw = gtk_pixmap_new(icon, mask);
	stop_button = gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),
						"List",
						_(" Shift + F"),
						"Private",
						iconw,
						GTK_SIGNAL_FUNC(download_stop),
						NULL);

	icon = gdk_pixmap_create_from_xpm_d(window->window,
					&mask,
					&window->style->white,
					restart_xpm);
    	iconw = gtk_pixmap_new(icon, mask);
	restart_button = gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),
						"List",
						_("ɤľ Shift + R"),
						"Private",
						iconw,
						GTK_SIGNAL_FUNC(download_restart),
						NULL);

	icon = gdk_pixmap_create_from_xpm_d(window->window,
					&mask,
					&window->style->white,
					trash2_xpm);
    	iconw = gtk_pixmap_new(icon, mask);
	remove_button = gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),
						"List",
						_("ꥹȤ Shift + D"),
						"Private",
						iconw,
						GTK_SIGNAL_FUNC(remove_cb),
						NULL);
	
	gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));

	
	icon = gdk_pixmap_create_from_xpm_d(window->window,
					&mask,
					&window->style->white,
					property_xpm);
    	iconw = gtk_pixmap_new(icon, mask);
	gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),
						"List",
						_("ΤΥץѥƥ"),
						"Private",
						iconw,
						GTK_SIGNAL_FUNC(property_create),
						NULL);

	icon = gdk_pixmap_create_from_xpm_d(window->window,
					&mask,
					&window->style->white,
					property2_xpm);
    	iconw = gtk_pixmap_new(icon, mask);
	property2_button = gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),
						"List",
						_("̤Υץѥƥ"),
						"Private",
						iconw,
						GTK_SIGNAL_FUNC(file_property_show),
						NULL);

	gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));

	icon = gdk_pixmap_create_from_xpm_d(window->window,
					&mask,
					&window->style->white,
					up_xpm);
    	iconw = gtk_pixmap_new(icon, mask);
	gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),
						"List",
						_("ľ˰ư Shift + Q"),
						"Private",
						iconw,
						GTK_SIGNAL_FUNC(move_up),
						NULL);

	
	icon = gdk_pixmap_create_from_xpm_d(window->window,
					&mask,
					&window->style->white,
					down_xpm);
    	iconw = gtk_pixmap_new(icon, mask);
	gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),
						"List",
						_("Ĳ˰ư Shift + A"),
						"Private",
						iconw,
						GTK_SIGNAL_FUNC(move_down),
						NULL);

/*	ǭbigɽ	*/
	
	
	giko_button = gtk_button_new();
	gtk_box_pack_end(GTK_BOX(hbox),giko_button ,FALSE ,FALSE ,2);
	gtk_widget_set_usize(GTK_WIDGET(giko_button) ,40 ,20);
	
	gtk_widget_show(giko_button);

	icon = gdk_pixmap_create_from_xpm_d(window->window,
					&mask,
					&window->style->white,
					giko_big3_xpm);
	iconw = gtk_pixmap_new(icon ,mask);
	gtk_container_add(GTK_CONTAINER(giko_button) ,iconw);
	gtk_widget_show(iconw);

	return;
}  

void
menu_toolbar_set_state(GtkCList *clist)
{
	FileData *file_data;

	if(clist->selection == NULL){
		gtk_widget_set_sensitive(GTK_WIDGET(start_button),FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(stop_button),FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(restart_button),FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(remove_button),FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(property2_button),FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(menu_start),FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(menu_stop),FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(menu_restart),FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(menu_trash),FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(menu_property2) ,FALSE);
	}else if(clist->selection->next == NULL){
		gtk_widget_set_sensitive(GTK_WIDGET(remove_button),TRUE);
		gtk_widget_set_sensitive(GTK_WIDGET(menu_trash),TRUE);
		gtk_widget_set_sensitive(GTK_WIDGET(property2_button),TRUE);
		gtk_widget_set_sensitive(GTK_WIDGET(menu_property2),TRUE);
		file_data = (FileData *)gtk_clist_get_row_data (clist, (gint) clist->selection->data);
		if(file_data->state == DATA_NOT_STARTED
			|| file_data->state == DATA_NOT_RUNNING
			|| file_data->state == DATA_STOP){
			gtk_widget_set_sensitive(GTK_WIDGET(start_button),TRUE);
			gtk_widget_set_sensitive(GTK_WIDGET(menu_start),TRUE);
		}
		else{
			gtk_widget_set_sensitive(GTK_WIDGET(start_button),FALSE);
			gtk_widget_set_sensitive(GTK_WIDGET(menu_start),FALSE);
		}
		if(file_data->state == DATA_CONNECTED
			|| file_data->state == DATA_NOT_CONNECTED
			|| file_data->state == DATA_RETRIEVING){
			gtk_widget_set_sensitive(GTK_WIDGET(stop_button),TRUE);
			gtk_widget_set_sensitive(GTK_WIDGET(menu_stop),TRUE);
		}
		else{
			gtk_widget_set_sensitive(GTK_WIDGET(stop_button),FALSE);
			gtk_widget_set_sensitive(GTK_WIDGET(menu_stop),FALSE);
		}
		if(file_data->state == DATA_NOT_RUNNING
			|| file_data->state == DATA_COMPLETED){
			gtk_widget_set_sensitive(GTK_WIDGET(restart_button),TRUE);
			gtk_widget_set_sensitive(GTK_WIDGET(menu_restart),TRUE);
		}
		else{
			gtk_widget_set_sensitive(GTK_WIDGET(restart_button),FALSE);
			gtk_widget_set_sensitive(GTK_WIDGET(menu_restart),FALSE);
		}
	}
}  

	
