/* ǭ
 *  Copyright (C) 2000,2001 gchar
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include<gnome.h>
#include<libgnomeui/gnome-window-icon.h>
#include"property.h"
#include"giko_property.h"

Property	*property;
extern Giko_Property giko_prop;
gboolean	property_show_flag = 0;	/*ץѥƥΥե饰	*/

void
property_apply_download(Property *property)
{
	/*	ǥեȥǥ쥯ȥ	*/
	giko_prop.def_directry = g_strdup(gtk_entry_get_text(GTK_ENTRY(property->dir_entry)));
	gnome_config_set_string("def_directry",giko_prop.def_directry);
	
	/*	ɴλեκ	*/
	giko_prop.completed_remove = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(property->complete_delete_button));
	gnome_config_set_bool("completed_remove",giko_prop.completed_remove);

	/*	ȥ饤	*/
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(property->unlimit_retries))){
		giko_prop.num_retries = 0;
	}else{
		giko_prop.num_retries = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(property->retry_spin));
	}
	gnome_config_set_int("num_retries",giko_prop.num_retries);

	/*	ॢ	ñ̤ʬäѴ*/
	giko_prop.timeout = (gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(property->timeout_spin)) * 60);
	gnome_config_set_int("timeout",giko_prop.timeout);
/*	g_print("timeout = %d\n",giko_prop.timeout);
	g_print("retry = %d\n",giko_prop.num_retries);*/
	
	/*	ѥåFTP	*/
	giko_prop.passive_ftp = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(property->passive_ftp_button));
	gnome_config_set_bool("passive_ftp" ,giko_prop.passive_ftp);
/*	g_print("passive_ftp = %d\n" ,giko_prop.passive_ftp);*/
}

void
property_apply_http(Property *property)
{
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(property->none_button))){
		giko_prop.referer = 0;
	}else if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(property->index_button))){
		giko_prop.referer = 1;
	}else if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(property->url_button))){
		giko_prop.referer = 2;
	}else{
		giko_prop.referer = 3;
	}

	if(strcmp(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(property->agent_combo)->entry)) , "ʤ") == 0)
		giko_prop.user_agent = 0;
	if(strcmp(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(property->agent_combo)->entry)) , "Wget/1.6") == 0)
		giko_prop.user_agent = 1;
	if(strcmp(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(property->agent_combo)->entry)) , 
				"Mozilla/4.0 (compatible; MSIE 4.01; Windows 95)") == 0)
		giko_prop.user_agent = 2;
	if(strcmp(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(property->agent_combo)->entry)) , 
				"Mozilla/5.0 (X11; U; Linux 2.4.0-0.99.11 i586; en-US; rv:0.9.1) Gecko/20010607") == 0)
		giko_prop.user_agent = 3;
	if(strcmp(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(property->agent_combo)->entry)) , 
				"Mozilla/3.0 (DreamPassport/1.01)") == 0)
		giko_prop.user_agent = 4;
	if(strcmp(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(property->agent_combo)->entry)) , 
				"Galeon/0.11") == 0)
		giko_prop.user_agent = 5;
	if(strcmp(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(property->agent_combo)->entry)) , 
				"Konqueror/1.1.2") == 0)
		giko_prop.user_agent = 6;
	if(strcmp(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(property->agent_combo)->entry)) , 
				"DoCoMo/1.0/P207") == 0)
		giko_prop.user_agent = 7;
/*
	g_print("referer = %d\n",giko_prop.referer);
	g_print("user_agent = %d\n",giko_prop.user_agent);*/
/*	g_print("server = %d\n",giko_prop.server);*/
	gnome_config_set_int("referer",giko_prop.referer);
	gnome_config_set_int("server",giko_prop.server);
	gnome_config_set_int("user_agent",giko_prop.user_agent);
}
void
property_apply_proxy(Property *property)
{
	giko_prop.use_proxy = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(property->use_proxy));
	gnome_config_set_bool("use_proxy",giko_prop.use_proxy);
	
	giko_prop.proxy_user = g_strdup(gtk_entry_get_text(GTK_ENTRY(property->proxy_user)));
	gnome_config_set_string("proxy_user",giko_prop.proxy_user);

	giko_prop.proxy_password = g_strdup(gtk_entry_get_text(GTK_ENTRY(property->proxy_password)));
	gnome_config_set_string("proxy_password",giko_prop.proxy_password);

	giko_prop.proxy_http = g_strdup(gtk_entry_get_text(GTK_ENTRY(property->http_entry)));
	gnome_config_set_string("proxy_http",giko_prop.proxy_http);

/*	g_print("use = %d\n",giko_prop.use_proxy);
	g_print("name = %s\n",giko_prop.proxy_user);*/
}
	
void
property_apply_clipboard(Property *property)
{
	giko_prop.clipboard_html = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(property->clipboard_html_button));
	gnome_config_set_bool("clipboard_html",giko_prop.clipboard_html);
	
	giko_prop.clipboard_htm = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(property->clipboard_htm_button));
	gnome_config_set_bool("clipboard_htm",giko_prop.clipboard_htm);
	
	giko_prop.clipboard_png = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(property->clipboard_png_button));
	gnome_config_set_bool("clipboard_png",giko_prop.clipboard_png);
	
	giko_prop.clipboard_jpg = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(property->clipboard_jpg_button));
	gnome_config_set_bool("clipboard_jpg",giko_prop.clipboard_jpg);
	
	giko_prop.clipboard_jpeg = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(property->clipboard_jpeg_button));
	gnome_config_set_bool("clipboard_jpeg",giko_prop.clipboard_jpeg);
	
	giko_prop.clipboard_gif = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(property->clipboard_gif_button));
	gnome_config_set_bool("clipboard_gif",giko_prop.clipboard_gif);
	
	giko_prop.clipboard_asp = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(property->clipboard_asp_button));
	gnome_config_set_bool("clipboard_asp",giko_prop.clipboard_asp);
}

void
property_apply_sound(Property *property)
{
	giko_prop.use_add_beep = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(property->check_add_beep));
	gnome_config_set_bool("use_add_beep",giko_prop.use_add_beep);
	
	giko_prop.use_error_beep = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(property->check_error_beep));
	gnome_config_set_bool("use_error_beep",giko_prop.use_error_beep);
		
	giko_prop.use_complete_beep = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(property->check_complete_beep));
	gnome_config_set_bool("use_complete_beep",giko_prop.use_complete_beep);
}

void
property_apply(GtkWidget *widget, gint page_num, Property *property)
{
	if(page_num == -1)
		return;

	gnome_config_push_prefix ("/giko_download/Property/");

	switch(page_num){
		case 0:
			/*		*/
			property_apply_download(property);
			break;
		case 1:
			/*	HTTP	*/
			property_apply_http(property);
			break;
		case 2:
			/*	ץ	*/
			property_apply_proxy(property);
			break;
		case 3:
			/*	ư	*/
			
			break;
		
		case 4:
			/*åץܡ*/
			property_apply_clipboard(property);
			break;
			
		case 5:
			/*		*/
			property_apply_sound(property);
			break;
	}
	gnome_config_pop_prefix();
	gnome_config_sync();
}

void
property_modified_cb(GtkWidget *widget,Property *property)
{

	
	/*	ȥ饤Υԥܥѹ	*/
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(property->unlimit_retries)))
		gtk_widget_set_sensitive(GTK_WIDGET(property->retry_spin),FALSE);
	else
		gtk_widget_set_sensitive(GTK_WIDGET(property->retry_spin),TRUE);

	/*	Referer ΥС	*/
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(property->server_button)))
		gtk_widget_set_sensitive(GTK_WIDGET(property->optionmenu),TRUE);
	else
		gtk_widget_set_sensitive(GTK_WIDGET(property->optionmenu),FALSE);

	/*	ץuse åܥѹ	*/
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(property->use_proxy))){
		gtk_widget_set_sensitive(GTK_WIDGET(property->proxy_user),TRUE);
		gtk_widget_set_sensitive(GTK_WIDGET(property->proxy_password),TRUE);
		gtk_widget_set_sensitive(GTK_WIDGET(property->http_entry),TRUE);
	}else{
		gtk_widget_set_sensitive(GTK_WIDGET(property->proxy_user),FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(property->proxy_password),FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(property->http_entry),FALSE);
	}
	
	gnome_property_box_changed(GNOME_PROPERTY_BOX(property->pbox));
}

void
create_download_page(Property *property)
{
	GtkWidget *vbox;
	GtkWidget *label;
	GtkWidget *hbox;
	GtkWidget *hbox2;
	GtkWidget *hbox3;
	GtkWidget *default_label;
	GtkWidget *timeout_label;
	GtkWidget *retry_label;
	GtkWidget *dir_entry;
	GSList	*group;
	GtkWidget *radio_button;
	GtkObject	*adjustment;

	vbox = gtk_vbox_new(FALSE,3);
	gtk_widget_show(vbox);

	label = gtk_label_new("  ");
	gtk_widget_show(label);

	hbox = gtk_hbox_new(FALSE,2);
	gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,3);
	gtk_widget_show(hbox);

	default_label = gtk_label_new("ǥե");
	gtk_box_pack_start(GTK_BOX(hbox),default_label,FALSE,FALSE,3);
	gtk_widget_show(default_label);

	dir_entry = gnome_file_entry_new ("ǥեȥǥ쥯ȥ","ǥեȥǥ쥯ȥ");
	property->dir_entry = gnome_file_entry_gtk_entry (GNOME_FILE_ENTRY (dir_entry));
	gnome_file_entry_set_directory (GNOME_FILE_ENTRY (dir_entry), 1);
	gtk_box_pack_start(GTK_BOX(hbox),dir_entry,FALSE,FALSE,3);
	gtk_entry_set_text(GTK_ENTRY(property->dir_entry),giko_prop.def_directry);
	gtk_signal_connect(GTK_OBJECT(property->dir_entry),"changed",
							GTK_SIGNAL_FUNC(property_modified_cb),property);
	gtk_widget_show(dir_entry);

/*	ۡǥ쥯ȥGET	*/
	/*homedir = g_get_home_dir();*/
	
	hbox = gtk_hbox_new(FALSE,2);
	gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,3);
	gtk_widget_show(hbox);

	property->complete_delete_button = gtk_check_button_new_with_label("ɤλ饢ƥ");
	gtk_box_pack_start(GTK_BOX(hbox),property->complete_delete_button,FALSE,FALSE,3);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(property->complete_delete_button),giko_prop.completed_remove);
	gtk_signal_connect(GTK_OBJECT(property->complete_delete_button),"clicked",
							GTK_SIGNAL_FUNC(property_modified_cb),property);
	gtk_widget_show(property->complete_delete_button);

	hbox2 = gtk_hbox_new(FALSE,2);
	gtk_box_pack_start(GTK_BOX(vbox),hbox2,FALSE,FALSE,3);
	gtk_widget_show(hbox2);

/*	ॢ	*/
	timeout_label = gtk_label_new("ॢ (ǥե 15ʬ)");
	gtk_box_pack_start(GTK_BOX(hbox2),timeout_label,FALSE,FALSE,2);
	gtk_widget_show(timeout_label);

	adjustment = gtk_adjustment_new(15 ,5 ,30 ,1 ,1 ,0);
	property->timeout_spin = gtk_spin_button_new(GTK_ADJUSTMENT(adjustment) ,1 ,0);
	gtk_entry_set_editable(GTK_ENTRY(property->timeout_spin),FALSE);
	gtk_box_pack_start(GTK_BOX(hbox2),property->timeout_spin,FALSE,FALSE,2);
	gtk_adjustment_set_value(GTK_ADJUSTMENT(adjustment),(float)(giko_prop.timeout / 60));
	gtk_signal_connect(GTK_OBJECT(property->timeout_spin),"changed",
							GTK_SIGNAL_FUNC(property_modified_cb),property);
	gtk_widget_show(property->timeout_spin);

	hbox3 = gtk_hbox_new(FALSE,2);
	gtk_box_pack_start(GTK_BOX(vbox),hbox3,FALSE,FALSE,3);
	gtk_widget_show(hbox3);

	retry_label = gtk_label_new("ȥ饤(ǥե̵)");
	gtk_box_pack_start(GTK_BOX(hbox3),retry_label,FALSE,FALSE,2);
	gtk_widget_show(retry_label);

	group = NULL;
	property->unlimit_retries = gtk_radio_button_new_with_label(group ,"̵");
	gtk_box_pack_start(GTK_BOX(hbox3),property->unlimit_retries ,FALSE,FALSE,2);
	gtk_signal_connect(GTK_OBJECT(property->unlimit_retries),"clicked",
							GTK_SIGNAL_FUNC(property_modified_cb),property);
	gtk_widget_show(property->unlimit_retries);

	group = gtk_radio_button_group(GTK_RADIO_BUTTON(property->unlimit_retries));
	radio_button = gtk_radio_button_new_with_label(group ,"");
	gtk_box_pack_start(GTK_BOX(hbox3),radio_button,FALSE,FALSE,2);
	gtk_signal_connect(GTK_OBJECT(radio_button),"clicked",
							GTK_SIGNAL_FUNC(property_modified_cb),property);
	gtk_widget_show(radio_button);

	adjustment = gtk_adjustment_new (1, 1, INT_MAX, 1, 100, 100);
	property->retry_spin = gtk_spin_button_new(GTK_ADJUSTMENT(adjustment) ,1 ,0);
	gtk_entry_set_editable(GTK_ENTRY(property->retry_spin) ,FALSE);
	gtk_box_pack_start(GTK_BOX(hbox3),property->retry_spin,FALSE,FALSE,2);
	if(giko_prop.num_retries == 0){
		gtk_widget_set_sensitive(GTK_WIDGET(property->retry_spin) ,FALSE);
	}else{
		gtk_widget_set_sensitive(GTK_WIDGET(property->retry_spin), TRUE);
		gtk_spin_button_set_value(GTK_SPIN_BUTTON(property->retry_spin),(gfloat)giko_prop.num_retries);
	}
	gtk_signal_connect(GTK_OBJECT(property->retry_spin),"changed",
							GTK_SIGNAL_FUNC(property_modified_cb),property);
	gtk_widget_show(property->retry_spin);
	
	property->passive_ftp_button = gtk_check_button_new_with_label("ѥåFTP");
	gtk_box_pack_start(GTK_BOX(vbox) ,property->passive_ftp_button ,FALSE ,FALSE ,3);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(property->passive_ftp_button),giko_prop.passive_ftp);
	gtk_signal_connect(GTK_OBJECT(property->passive_ftp_button),"clicked",
							GTK_SIGNAL_FUNC(property_modified_cb),property);
	gtk_widget_show(property->passive_ftp_button);

	gnome_property_box_append_page(GNOME_PROPERTY_BOX(property->pbox),vbox,label);
	
}

void
property_server_changed(GtkWidget *widget ,gchar *data)
{
	giko_prop.server = (gint)data;
	gnome_property_box_changed(GNOME_PROPERTY_BOX(property->pbox));
}

void
create_http_page(Property *property)
{
	GtkWidget *vbox;
	GtkWidget *label;
	GtkWidget *ref_frame;
	GtkWidget *ref_vbox;
	GSList 	   *ref_group;
	GtkWidget *ref_hbox;
	GList *server_glist = NULL;
	GtkWidget *agent_frame;
	GList *agent_glist = NULL;

	
	GtkWidget *menu;
	GtkWidget *menu_item1;
	GtkWidget *menu_item2;
	
	vbox = gtk_vbox_new(FALSE,3);
	gtk_widget_show(vbox);

	label = gtk_label_new(" http ");
	gtk_widget_show(label);

	ref_frame = gtk_frame_new(" Referer ");
	gtk_box_pack_start(GTK_BOX(vbox),ref_frame,TRUE,TRUE,8);	
	gtk_widget_show(ref_frame);

	ref_vbox = gtk_vbox_new(FALSE,2);
	gtk_container_add(GTK_CONTAINER(ref_frame),ref_vbox);
	gtk_widget_show(ref_vbox);


	
	property->none_button = gtk_radio_button_new_with_label(NULL,"ʤ");
	gtk_box_pack_start(GTK_BOX(ref_vbox),property->none_button,FALSE,FALSE,2);
	if(giko_prop.referer == 0)
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(property->none_button),TRUE);
	gtk_widget_show(property->none_button);
	
	ref_group = gtk_radio_button_group(GTK_RADIO_BUTTON(property->none_button));
	property->index_button = gtk_radio_button_new_with_label(ref_group,"index.html");
	gtk_box_pack_start(GTK_BOX(ref_vbox),property->index_button,FALSE,FALSE,2);
	if(giko_prop.referer == 1)
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(property->index_button),TRUE);
	gtk_widget_show(property->index_button);

	ref_group = gtk_radio_button_group(GTK_RADIO_BUTTON(property->index_button));
	property->url_button = gtk_radio_button_new_with_label(ref_group,"URL");
	gtk_box_pack_start(GTK_BOX(ref_vbox),property->url_button,FALSE,FALSE,2);
	if(giko_prop.referer == 2)
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(property->url_button),TRUE);
	gtk_widget_show(property->url_button);

	ref_hbox = gtk_hbox_new(FALSE,2);
	gtk_box_pack_start(GTK_BOX(ref_vbox),ref_hbox,FALSE,FALSE,2);
	gtk_widget_show(ref_hbox);
	
	ref_group = gtk_radio_button_group(GTK_RADIO_BUTTON(property->url_button));
	property->server_button = gtk_radio_button_new_with_label(ref_group,"С");
	gtk_box_pack_start(GTK_BOX(ref_hbox),property->server_button,FALSE,FALSE,2);
	if(giko_prop.referer == 3)
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(property->server_button),TRUE);
	gtk_widget_show(property->server_button);

/*	СΥץ˥塼	*/
	property->optionmenu = gtk_option_menu_new();
	gtk_box_pack_end(GTK_BOX(ref_hbox),property->optionmenu,FALSE,FALSE,2);
	gtk_widget_show(property->optionmenu);
	
	menu = gtk_menu_new();
	
/*     iYahoo	*/
	menu_item1 = gtk_menu_item_new_with_label(" iYahoo!");
	gtk_menu_append(GTK_MENU(menu),menu_item1);
	gtk_widget_show(menu_item1);

/*     yYahoo	*/
	menu_item2 = gtk_menu_item_new_with_label(" yYahoo!");
	gtk_menu_append(GTK_MENU(menu),menu_item2);
	gtk_widget_show(menu_item2);

	gtk_menu_set_active(GTK_MENU(menu),giko_prop.server);
	gtk_option_menu_set_menu (GTK_OPTION_MENU (property->optionmenu),
                              menu);
/*	User	Agent	*/
	agent_frame = gtk_frame_new(" User Agent ");
	gtk_box_pack_start(GTK_BOX(vbox),agent_frame,TRUE,TRUE,8);
	gtk_widget_show(agent_frame);

/*	Wget/1.6
	 User-Agent: Mozilla/1.1N (Macintosh; I; 68K)
	Mozilla/4.0 (compatible; MSIE 4.01; Windows 95)
	Mozilla/5.0 (X11; U; Linux 2.4.0-0.99.11 i586; en-US; rv:0.9.1) Gecko/20010607
	DoCoMo/1.0/P502i
	Konqueror/1.1.2
	Mozilla/3.0 (DreamPassport/1.01)
'Referer: http://www.2ch.net/unix/index2.html'
*/
	property->agent_combo = gtk_combo_new();
	gtk_container_add(GTK_CONTAINER(agent_frame),property->agent_combo);
	gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(property->agent_combo)->entry),FALSE);
	gtk_widget_show(property->agent_combo);
		
	agent_glist = g_list_append(agent_glist,"ʤ");
	agent_glist = g_list_append(agent_glist,"Wget/1.6");
	agent_glist = g_list_append(agent_glist,"Mozilla/4.0 (compatible; MSIE 4.01; Windows 95)");
	agent_glist = g_list_append(agent_glist,"Mozilla/5.0 (X11; U; Linux 2.4.0-0.99.11 i586; en-US; rv:0.9.1) Gecko/20010607");
	agent_glist = g_list_append(agent_glist,"Mozilla/3.0 (DreamPassport/1.01)");
	agent_glist = g_list_append(agent_glist,"Galeon/0.11");
	agent_glist = g_list_append(agent_glist,"Konqueror/1.1.2");
	agent_glist = g_list_append(agent_glist,"DoCoMo/1.0/P207");
	gtk_combo_set_popdown_strings(GTK_COMBO(property->agent_combo) ,agent_glist);
	gtk_signal_connect(GTK_OBJECT(GTK_COMBO(property->agent_combo)->entry),"changed",
							GTK_SIGNAL_FUNC(property_modified_cb),property);

	/*	Referer Υʥ	*/
	gtk_signal_connect(GTK_OBJECT(property->index_button),"clicked",
							GTK_SIGNAL_FUNC(property_modified_cb),property);
	gtk_signal_connect(GTK_OBJECT(property->none_button),"clicked",
							GTK_SIGNAL_FUNC(property_modified_cb),property);
	gtk_signal_connect(GTK_OBJECT(property->url_button),"clicked",
							GTK_SIGNAL_FUNC(property_modified_cb),property);
	gtk_signal_connect(GTK_OBJECT(property->server_button),"clicked",
							GTK_SIGNAL_FUNC(property_modified_cb),property);
	
	/*	С˥塼Υʥ	*/
	if(giko_prop.referer == 3)
		gtk_widget_set_sensitive(GTK_WIDGET(property->optionmenu) ,TRUE);
	else
		gtk_widget_set_sensitive(GTK_WIDGET(property->optionmenu) ,FALSE);
	gtk_signal_connect(GTK_OBJECT(menu_item1),"activate",
					GTK_SIGNAL_FUNC(property_server_changed),(gpointer)0);
	gtk_signal_connect(GTK_OBJECT(menu_item2),"activate",
					GTK_SIGNAL_FUNC(property_server_changed),(gpointer)1);
		
	gnome_property_box_append_page(GNOME_PROPERTY_BOX(property->pbox),vbox,label);
}

void
create_auto_page(Property *property)
{
	GtkWidget *vbox;
	GtkWidget *label;

	vbox = gtk_vbox_new(FALSE,3);
	gtk_widget_show(vbox);

	label = gtk_label_new(" ư ");
	gtk_widget_show(label);

	gnome_property_box_append_page(GNOME_PROPERTY_BOX(property->pbox),vbox,label);
}
void
create_proxy_page(Property *property)
{
	GtkWidget *vbox;
	GtkWidget *label;
	GtkWidget *hbox;
	GtkWidget *user_label;
	GtkWidget *pass_label;
	GtkWidget *http_label;

	vbox = gtk_vbox_new(FALSE,3);	
	gtk_widget_show(vbox);

	label = gtk_label_new(" PROXY ");
	gtk_widget_show(label);

	property->use_proxy = gtk_check_button_new_with_label("ץλ");
	gtk_box_pack_start(GTK_BOX(vbox),property->use_proxy,FALSE,FALSE,2);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(property->use_proxy),giko_prop.use_proxy);
	gtk_signal_connect(GTK_OBJECT(property->use_proxy),"clicked",
							GTK_SIGNAL_FUNC(property_modified_cb),property);
	gtk_widget_show(property->use_proxy);

	hbox = gtk_hbox_new(FALSE ,3);
	gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE ,2);
	gtk_widget_show(hbox);

	user_label = gtk_label_new("桼̾   ");
	gtk_box_pack_start(GTK_BOX(hbox),user_label ,FALSE,FALSE,2);
	gtk_widget_show(user_label);

	property->proxy_user = gtk_entry_new();
	gtk_box_pack_start(GTK_BOX(hbox),property->proxy_user ,FALSE ,FALSE ,2);
	gtk_entry_set_text(GTK_ENTRY(property->proxy_user),giko_prop.proxy_user);
	if(giko_prop.use_proxy == FALSE)
		gtk_widget_set_sensitive(GTK_WIDGET(property->proxy_user) ,FALSE);
	gtk_signal_connect(GTK_OBJECT(property->proxy_user),"changed",
						GTK_SIGNAL_FUNC(property_modified_cb),property);
	gtk_widget_show(property->proxy_user);

	hbox = gtk_hbox_new(FALSE ,3);
	gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE ,2);
	gtk_widget_show(hbox);

	pass_label = gtk_label_new("ѥ");
	gtk_box_pack_start(GTK_BOX(hbox),pass_label ,FALSE,FALSE,2);
	gtk_widget_show(pass_label);

	property->proxy_password = gtk_entry_new();
	gtk_box_pack_start(GTK_BOX(hbox),property->proxy_password ,FALSE ,FALSE ,2);
	gtk_entry_set_text(GTK_ENTRY(property->proxy_password) ,giko_prop.proxy_password);
	if(giko_prop.use_proxy == FALSE)
		gtk_widget_set_sensitive(GTK_WIDGET(property->proxy_password) ,FALSE);
	gtk_signal_connect(GTK_OBJECT(property->proxy_password),"changed",
						GTK_SIGNAL_FUNC(property_modified_cb),property);
	gtk_widget_show(property->proxy_password);

	hbox = gtk_hbox_new(FALSE ,3);
	gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE ,2);
	gtk_widget_show(hbox);

	http_label = gtk_label_new("HTTP  ");
	gtk_box_pack_start(GTK_BOX(hbox),http_label ,FALSE,FALSE,2);
	gtk_widget_show(http_label);

	property->http_entry = gtk_entry_new();
	gtk_box_pack_start(GTK_BOX(hbox),property->http_entry ,TRUE,TRUE ,2);
	gtk_entry_set_text(GTK_ENTRY(property->http_entry) ,giko_prop.proxy_http);
	if(giko_prop.use_proxy == FALSE)
		gtk_widget_set_sensitive(GTK_WIDGET(property->http_entry) ,FALSE);
	gtk_signal_connect(GTK_OBJECT(property->http_entry),"changed",
						GTK_SIGNAL_FUNC(property_modified_cb),property);
	gtk_widget_show(property->http_entry);




	

	gnome_property_box_append_page(GNOME_PROPERTY_BOX(property->pbox),vbox,label);
}

void
create_clipboard_page(Property *property)
{
	GtkWidget *vbox;
	GtkWidget *label;
	GtkWidget *label2;
	
	vbox = gtk_vbox_new(FALSE ,2);
	gtk_widget_show(vbox);
	
	label = gtk_label_new("åץܡ");
	gtk_widget_show(label);
	
	label2 = gtk_label_new(" åդƤĥҤ̵뤹 ");
	gtk_box_pack_start(GTK_BOX(vbox) ,label2 ,FALSE ,FALSE ,3);
	gtk_widget_show(label2);
	
	property->clipboard_html_button = gtk_check_button_new_with_label(" html");
	gtk_box_pack_start(GTK_BOX(vbox) ,property->clipboard_html_button ,FALSE ,FALSE ,2);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(property->clipboard_html_button),giko_prop.clipboard_html);
	gtk_signal_connect(GTK_OBJECT(property->clipboard_html_button),"clicked",
							GTK_SIGNAL_FUNC(property_modified_cb),property);
	gtk_widget_show(property->clipboard_html_button);
	
	/*htm*/
	property->clipboard_htm_button = gtk_check_button_new_with_label(" htm");
	gtk_box_pack_start(GTK_BOX(vbox) ,property->clipboard_htm_button ,FALSE ,FALSE ,2);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(property->clipboard_htm_button),giko_prop.clipboard_htm);
	gtk_signal_connect(GTK_OBJECT(property->clipboard_htm_button),"clicked",
							GTK_SIGNAL_FUNC(property_modified_cb),property);
	gtk_widget_show(property->clipboard_htm_button);
	
	/*png*/
	property->clipboard_png_button = gtk_check_button_new_with_label(" png");
	gtk_box_pack_start(GTK_BOX(vbox) ,property->clipboard_png_button ,FALSE ,FALSE ,2);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(property->clipboard_png_button),giko_prop.clipboard_png);
	gtk_signal_connect(GTK_OBJECT(property->clipboard_png_button),"clicked",
							GTK_SIGNAL_FUNC(property_modified_cb),property);
	gtk_widget_show(property->clipboard_png_button);
	
	/*jpg*/
	property->clipboard_jpg_button = gtk_check_button_new_with_label(" jpg");
	gtk_box_pack_start(GTK_BOX(vbox) ,property->clipboard_jpg_button ,FALSE ,FALSE ,2);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(property->clipboard_jpg_button),giko_prop.clipboard_jpg);
	gtk_signal_connect(GTK_OBJECT(property->clipboard_jpg_button),"clicked",
							GTK_SIGNAL_FUNC(property_modified_cb),property);
	gtk_widget_show(property->clipboard_jpg_button);
	
	/*jpeg*/
	property->clipboard_jpeg_button = gtk_check_button_new_with_label(" jpeg");
	gtk_box_pack_start(GTK_BOX(vbox) ,property->clipboard_jpeg_button ,FALSE ,FALSE ,2);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(property->clipboard_jpeg_button),giko_prop.clipboard_jpeg);
	gtk_signal_connect(GTK_OBJECT(property->clipboard_jpeg_button),"clicked",
							GTK_SIGNAL_FUNC(property_modified_cb),property);
	gtk_widget_show(property->clipboard_jpeg_button);
	
	/*gif*/
	property->clipboard_gif_button = gtk_check_button_new_with_label(" gif");
	gtk_box_pack_start(GTK_BOX(vbox) ,property->clipboard_gif_button ,FALSE ,FALSE ,2);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(property->clipboard_gif_button),giko_prop.clipboard_gif);
	gtk_signal_connect(GTK_OBJECT(property->clipboard_gif_button),"clicked",
							GTK_SIGNAL_FUNC(property_modified_cb),property);
	gtk_widget_show(property->clipboard_gif_button);
	
	/*asp*/
	property->clipboard_asp_button = gtk_check_button_new_with_label(" asp");
	gtk_box_pack_start(GTK_BOX(vbox) ,property->clipboard_asp_button ,FALSE ,FALSE ,2);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(property->clipboard_asp_button),giko_prop.clipboard_asp);
	gtk_signal_connect(GTK_OBJECT(property->clipboard_asp_button),"clicked",
							GTK_SIGNAL_FUNC(property_modified_cb),property);
	gtk_widget_show(property->clipboard_asp_button);
	
	gnome_property_box_append_page(GNOME_PROPERTY_BOX(property->pbox),vbox,label);
}

/*
void
create_directry_page(Property	*property)
{
	GtkWidget *vbox;
	GtkWidget *label;
	GtkWidget *label2;
	GtkWidget *hbox;
	GtkWidget *button1;
	GtkWidget *button2;
	GtkWidget *button3;
	gchar	*title[1];
	GtkWidget *scrolled_window;
	
	vbox = gtk_vbox_new(FALSE ,2);
	gtk_widget_show(vbox);

	label = gtk_label_new(" ǥ쥯ȥ ");
	gtk_widget_show(label);

	label2 = gtk_label_new("ˤ˻Ȥɥǥ쥯ȥϿ");
	gtk_box_pack_start(GTK_BOX(vbox),label2,FALSE ,FALSE ,2);
	gtk_widget_show(label2);

	hbox = gtk_hbox_new(FALSE ,2);
	gtk_box_pack_start(GTK_BOX(vbox ) ,hbox ,FALSE ,FALSE ,2);
	gtk_widget_show(hbox);

	button1 = gtk_button_new_with_label("");
	gtk_box_pack_start(GTK_BOX(hbox) ,button1 ,TRUE ,FALSE ,1);
	gtk_signal_connect(GTK_OBJECT(button1) ,"clicked",
							GTK_SIGNAL_FUNC(dir_insert) ,property);
	gtk_widget_show(button1);

	button2 = gtk_button_new_with_label("Խ");
	gtk_box_pack_start(GTK_BOX(hbox) ,button2 ,TRUE ,FALSE ,1);
	gtk_widget_show(button2);

	button3 = gtk_button_new_with_label("");
	gtk_box_pack_start(GTK_BOX(hbox) ,button3 ,TRUE ,FALSE ,1);
	gtk_widget_show(button3);

	scrolled_window = gtk_scrolled_window_new(NULL ,NULL);
	gtk_box_pack_start(GTK_BOX(vbox) ,scrolled_window ,TRUE, TRUE ,2);
	gtk_container_border_with(GTK_CONTAINER(scrolled_window) ,10);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window),
				    GTK_POLICY_AUTOMATIC,
				    GTK_POLICY_AUTOMATIC);
	gtk_widget_show(scrolled_window);

	title[0]  = "ǥ쥯ȥ";
	property->dir_clist = gtk_clist_new_with_titles(1,title);
	gtk_container_add(GTK_CONTAINER(scrolled_window) ,property->dir_clist);
	gtk_widget_show(property->dir_clist);

	gnome_property_box_append_page(GNOME_PROPERTY_BOX(property->pbox),vbox,label);
}
	
*/

void
create_sound_page(Property	*property)
{
	GtkWidget *vbox;
	GtkWidget *label;
	GtkWidget *frame;
	GtkWidget *vbox2;
	
	vbox = gtk_vbox_new(FALSE,2);
	gtk_widget_show(vbox);

	label = gtk_label_new("  ");
	gtk_widget_show(label);

	property->check_sound = gtk_check_button_new_with_label("ɤλ");
	gtk_box_pack_start(GTK_BOX(vbox),property->check_sound,FALSE,FALSE,3);
	gtk_widget_set_sensitive(GTK_WIDGET(property->check_sound),FALSE);
	gtk_widget_show(property->check_sound);

	frame = gtk_frame_new("ӡײλ");
	gtk_frame_set_shadow_type(GTK_FRAME(frame) ,GTK_SHADOW_ETCHED_OUT);
	gtk_box_pack_start(GTK_BOX(vbox),frame,FALSE ,FALSE,3);
	gtk_widget_show(frame);

	vbox2 = gtk_vbox_new(FALSE ,2);
	gtk_container_add(GTK_CONTAINER(frame),vbox2 );
	gtk_widget_show(vbox2);

	
	property->check_add_beep = gtk_check_button_new_with_label("եɲ");
	gtk_box_pack_start(GTK_BOX(vbox2),property->check_add_beep,FALSE,FALSE,3);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(property->check_add_beep),giko_prop.use_add_beep);
	gtk_signal_connect(GTK_OBJECT(property->check_add_beep),"clicked",
						GTK_SIGNAL_FUNC(property_modified_cb),(gpointer)property);
	gtk_widget_show(property->check_add_beep);

	property->check_error_beep = gtk_check_button_new_with_label("եɲäΥ顼");
	gtk_box_pack_start(GTK_BOX(vbox2),property->check_error_beep,FALSE,FALSE,3);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(property->check_error_beep),giko_prop.use_error_beep);
	gtk_signal_connect(GTK_OBJECT(property->check_error_beep),"clicked",
						GTK_SIGNAL_FUNC(property_modified_cb),(gpointer)property);
	gtk_widget_show(property->check_error_beep);

	property->check_complete_beep = gtk_check_button_new_with_label("ɴλ");
	gtk_box_pack_start(GTK_BOX(vbox2),property->check_complete_beep,FALSE,FALSE ,3);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(property->check_complete_beep),giko_prop.use_complete_beep);
	gtk_signal_connect(GTK_OBJECT(property->check_complete_beep),"clicked",
						GTK_SIGNAL_FUNC(property_modified_cb),(gpointer)property);
	gtk_widget_show(property->check_complete_beep);


	gnome_property_box_append_page(GNOME_PROPERTY_BOX(property->pbox),vbox,label);
}

void
create_server_page(Property *property)
{
	GtkWidget *vbox;
	GtkWidget *label;
	GtkWidget *label2;
	GtkWidget *scrolled_window;
	gchar *title[2];
	gchar *server[2];
	GtkWidget *clist;

	vbox = gtk_vbox_new(FALSE,2);
	gtk_widget_show(vbox);

	label = gtk_label_new(" С ");
	gtk_widget_show(label);

	label2 = gtk_label_new("бƤ륵С");
	gtk_box_pack_start(GTK_BOX(vbox) ,label2 ,FALSE ,FALSE ,2);
	gtk_widget_show(label2);

	scrolled_window = gtk_scrolled_window_new(NULL ,NULL);
	gtk_box_pack_start(GTK_BOX(vbox) ,scrolled_window ,FALSE ,FALSE ,2);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window),
				    GTK_POLICY_AUTOMATIC,
				    GTK_POLICY_AUTOMATIC);
	
	gtk_widget_set_usize(GTK_WIDGET(scrolled_window) ,200 ,200);
	gtk_widget_show(scrolled_window);

	title[0] = " С̾";
	title[1] = " ɥ쥹";
	clist = gtk_clist_new_with_titles(2 ,title);
	gtk_container_add(GTK_CONTAINER(scrolled_window) ,clist);
	gtk_clist_set_column_auto_resize(GTK_CLIST(clist),0,TRUE);
	gtk_clist_set_column_auto_resize(GTK_CLIST(clist),1,TRUE);
	gtk_widget_show(clist);

	server[0] = " iYahoo! ";
	server[1] = "***.yming.com";
	gtk_clist_append(GTK_CLIST(clist) ,server);
	
	

	server[0] = " yYahoo! ";
	server[1] = "us.f1.yahoofs.com";
	gtk_clist_append(GTK_CLIST(clist) ,server);
	
	
	server[0] = "";
	server[1] = "";
	gtk_clist_append(GTK_CLIST(clist) ,server);
	
	server[0] = "  ";
	server[1] = "";
	gtk_clist_append(GTK_CLIST(clist) ,server);
	
	server[0] = " homestead ";                
	server[1] = "www.homestead.com  ***.homestead.com";
	gtk_clist_append(GTK_CLIST(clist) ,server);
	
	server[0] = " 20m / 50m";
	server[1] = "***.20m.com  ***.50m.com";
	gtk_clist_append(GTK_CLIST(clist) ,server);

	/* iYahoo referer=http://briefcase.yahoo.com/bc/$randma(6)?c&.flabel=fld2&.src=bc*/

	/*yYahoo	http://y$randm(2).briefcase.yahoo.com/bc/$randma(8)/lst?.dir=/$randma(8)%26.src=bc%26.view=l&.view=l	*/


	
	gnome_property_box_append_page(GNOME_PROPERTY_BOX(property->pbox),vbox,label);
}
	
void
property_delete(GtkWidget *widget,gchar *data)
{
/*	g_print("property_delete\n");*/
}

void
property_destroy(GtkWidget *widget,Property *property)
{
	property_show_flag = 0;
	g_free(property);

}

void
property_create()
{
	
	
	if(property_show_flag == 1){
		/*gdk_window_raise (GTK_WIDGET (GNOME_DIALOG (property->pbox))->window);*/
		return;
	}
	property_show_flag = 1;
	property = g_new(Property ,1);
	property->pbox = gnome_property_box_new();
	gtk_window_set_title (GTK_WINDOW (property->pbox)," ǭ (ΤΥץѥƥ) ");
	gtk_widget_set_usize(GTK_WIDGET(property->pbox),600,350);
	gtk_signal_connect(GTK_OBJECT(property->pbox),"delete_event",
							GTK_SIGNAL_FUNC(property_delete),NULL);
	gtk_signal_connect(GTK_OBJECT(property->pbox),"destroy",
							GTK_SIGNAL_FUNC(property_destroy),property);
	gtk_signal_connect(GTK_OBJECT(property->pbox),"apply",
							GTK_SIGNAL_FUNC(property_apply),property);
	gnome_window_icon_set_from_file(GTK_WINDOW(property->pbox),"/usr/share/pixmaps/gikodown.png");
	
	gtk_notebook_set_scrollable(GTK_NOTEBOOK(GNOME_PROPERTY_BOX(property->pbox)->notebook) ,TRUE);
	gtk_container_set_border_width(GTK_CONTAINER(GNOME_PROPERTY_BOX(property->pbox)->notebook) ,5);
	
	create_download_page(property);
	create_http_page(property);
	create_proxy_page(property);
	create_auto_page(property);
/*	create_directry_page(property);	*/
	create_clipboard_page(property);
	create_sound_page(property);
	create_server_page(property);
	/*gtk_widget_show(property->pbox);*/
	gnome_dialog_run(GNOME_DIALOG(property->pbox));
	
	/*gnome_dialog_run_and_close(GNOME_DIALOG(property->pbox));*/
}  
